"use strict";
//Dephormation
// 
//Licence Terms
// 
//1) Dephormation is copyright Peter John
//
//You may;
//
//2) Download and install Dephormation software for personal or commercial use
//
//3) You may use Dephormation software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) Dephormation software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank, Baker & McKenzie
//
//8) Dephormation software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) Dephormation software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

window.addEventListener("load",   function() { dephormation.init();   }, false);
window.addEventListener("unload", function() { dephormation.uninit(); }, false);

// ------------------------------------------------------------------------------------------------
// Toggles false on page load, true after first alert displayed
var dephormationAlertShownFlag = false;

var dephormationPhormDomainHostRegExp       = "";
var dephormationOIXDomainHostRegExp         = "";
var dephormationOIXDomainLinkRegExp         = "";
var dephormationNonOIXDomainHostRegExp      = "";
var dephormationNonOIXDomainLinkRegExp      = "";
var dephormationOpPortalDomainHostRegExp    = "";
var dephormationOpPortalDomainLinkRegExp    = "";
var dephormationOCSLabDomainHostRegExp      = "";
var dephormationOCSLabDomainLinkRegExp      = "";
var dephormationPhormPartnerDomainHostRegExp= "";
var dephormationPhormPartnerDomainLinkRegExp= "";

function initialiseRegExps()
{
   var arrayOIXDomainRegExps = [
"(^|\\.|[a-z]+:\/\/)adobur\\.com",
"(^|\\.|[a-z]+:\/\/)adobur\\.net",
"(^|\\.|[a-z]+:\/\/)adoburcrv\\.com",
"(^|\\.|[a-z]+:\/\/)discoverdemo\\.com",
"(^|\\.|[a-z]+:\/\/)fengfengtie\\.com\\.cn",
"(^|\\.|[a-z]+:\/\/)fengfengtiecrv\\.com\\.cn",   
"(^|\\.|[a-z]+:\/\/)fengfengtiessp\\.com\\.cn", 
"(^|\\.|[a-z]+:\/\/)fideo\\.com",   
"(^|\\.|[a-z]+:\/\/)fideocrv\\.com", 
"(^|\\.|[a-z]+:\/\/)imrk\\.net",
"(^|\\.|[a-z]+:\/\/)imrk2\\.net",
"(^|\\.|[a-z]+:\/\/)imrksvr2\\.net",
"(^|\\.|[a-z]+:\/\/)imrkcrv\\.net",
"(^|\\.|[a-z]+:\/\/)imarker\\.com",
"(^|\\.|[a-z]+:\/\/)imarker\\.ru",
"(^|\\.|[a-z]+:\/\/)genni\\.com\\.cn",
"(^|\\.|[a-z]+:\/\/)gennicrv\\.com\\.cn",
"(^|\\.|[a-z]+:\/\/)moodoo\\.com\\.cn",
"(^|\\.|[a-z]+:\/\/)moodoocrv\\.com\\.cn",
"(^|\\.|[a-z]+:\/\/)moodoocn\\.com",
"(^|\\.|[a-z]+:\/\/)moodoocncrv\\.com",
"(^|\\.|[a-z]+:\/\/)oidiscover\\.com",
"(^|\\.|[a-z]+:\/\/)oix\\.com",
"(^|\\.|[a-z]+:\/\/)oix\\.net",
"(^|\\.|[a-z]+:\/\/)oix[0-9]\\.net",
"(^|\\.|[a-z]+:\/\/)oixcrv\\.net",
"(^|\\.|[a-z]+:\/\/)oixcrv-lab\\.net",
"(^|\\.|[a-z]+:\/\/)oixcrv-stage\\.net",
"(^|\\.|[a-z]+:\/\/)oixpre\\.net",
"(^|\\.|[a-z]+:\/\/)oixpre-lab\\.net",
"(^|\\.|[a-z]+:\/\/)oixpre-stage\\.net",
"(^|\\.|[a-z]+:\/\/)oixssp\\.net",
"(^|\\.|[a-z]+:\/\/)oixssp-lab\\.net",
"(^|\\.|[a-z]+:\/\/)oixssp-stage\\.net",
"(^|\\.|[a-z]+:\/\/)oix-stage\\.net",
"(^|\\.|[a-z]+:\/\/)oixchina\\.com",
"(^|\\.|[a-z]+:\/\/)phluidmedia\\.com",
"(^|\\.|[a-z]+:\/\/)phluidmedia\\.net",
"(^|\\.|[a-z]+:\/\/)phluidmediacrv\\.com",
"(^|\\.|[a-z]+:\/\/)phluidmediacrv\\.net",
"(^|\\.|[a-z]+:\/\/)phorm\\.com",
"(^|\\.|[a-z]+:\/\/)phorm\\.kr",
"(^|\\.|[a-z]+:\/\/)phormdev\\.com",
"(^|\\.|[a-z]+:\/\/)phormlabs\\.com",
"(^|\\.|[a-z]+:\/\/)phormchina\\.com",
"(^|\\.|[a-z]+:\/\/)phormkorea\\.com",
"(^|\\.|[a-z]+:\/\/)phormservice\\.com",
"(^|\\.|[a-z]+:\/\/)phormprivacy\\.com",
"(^|\\.|[a-z]+:\/\/)phormsolution\\.com",
"(^|\\.|[a-z]+:\/\/)phormstandards\\.com",
"(^|\\.|[a-z]+:\/\/)phorm\\.ch",
"(^|\\.|[a-z]+:\/\/)phorm\\.com\\.br",
"(^|\\.|[a-z]+:\/\/)phorm\\.com\\.es",
"(^|\\.|[a-z]+:\/\/)phorm\\.com\\.mx",
"(^|\\.|[a-z]+:\/\/)phorm\\.com\\.tr",
"(^|\\.|[a-z]+:\/\/)phorm\\.es",
"(^|\\.|[a-z]+:\/\/)phorm\\.in",
"(^|\\.|[a-z]+:\/\/)phorm\\.ro",
"(^|\\.|[a-z]+:\/\/)phorm\\.jp",
"(^|\\.|[a-z]+:\/\/)phorm\\.dk",
"(^|\\.|[a-z]+:\/\/)phorm\\.biz\\.tr",
"(^|\\.|[a-z]+:\/\/)phorm\\.co\\.in",
"(^|\\.|[a-z]+:\/\/)phorm\\.co\\.uk",
"(^|\\.|[a-z]+:\/\/)phorm\\.hk",
"(^|\\.|[a-z]+:\/\/)phorm\\.info\\.tr",
"(^|\\.|[a-z]+:\/\/)phorm\\.org\\.es",
"(^|\\.|[a-z]+:\/\/)phorm\\.nom\\.es",
"(^|\\.|[a-z]+:\/\/)phorm\\.tv\\.tr",
"(^|\\.|[a-z]+:\/\/)phorm\\.web\\.tr",
"(^|\\.|[a-z]+:\/\/)phorm\\.cl",
"(^|\\.|[a-z]+:\/\/)phormdiscover\\.com",
"(^|\\.|[a-z]+:\/\/)wovven\\.com",
"(^|\\.|[a-z]+:\/\/)wovvencrv\\.com",
"(^|\\.|[a-z]+:\/\/)wovven\\.net",
"(^|\\.|[a-z]+:\/\/)wovvencrv\\.net",
"(^|\\.|[a-z]+:\/\/)webwise\\.com",
"(^|\\.|[a-z]+:\/\/)webwise\\.net",
"(^|\\.|[a-z]+:\/\/)webwise\\.org",
"(^|\\.|[a-z]+:\/\/)webnavegador\\.com\\.br",
"(^|\\.|[a-z]+:\/\/)webnavegador\\.com",
"(^|\\.|[a-z]+:\/\/)ptreklam\\.com\\.tr",
"(^|\\.|[a-z]+:\/\/)ptreklamcrv\\.com\\.tr",
"(^|\\.|[a-z]+:\/\/)ptreklam\\.com",
"(^|\\.|[a-z]+:\/\/)ptreklamssp\\.com\\.tr",
"(^|\\.|[a-z]+:\/\/)ptreklamssp\\.com",
"(^|\\.|[a-z]+:\/\/)ptreklamssp\\.net",
"(^|\\.|[a-z]+:\/\/)ptreklamcrv\\.com",
"(^|\\.|[a-z]+:\/\/)ptreklamcrv\\.net",
"(^|\\.|[a-z]+:\/\/)ptreklam\\.net",
"(^|\\.|[a-z]+:\/\/)reklam-1\\.com",
"(^|\\.|[a-z]+:\/\/)reklam-one\\.com",
"(^|\\.|[a-z]+:\/\/)openinternetexchange\\.org",
"(^|\\.|[a-z]+:\/\/)openinternetexchange\\.com",
"(^|\\.|[a-z]+:\/\/)openinternetexchange\\.net",
"(^|\\.|[a-z]+:\/\/)gezinti\\.com",
"(^|\\.|[a-z]+:\/\/)sysip\\.net",
"(^|\\.|[a-z]+:\/\/)pagesense\\.com"
   ];
   var arrayNonOIXDomainRegExps = [
"(^|\\.|[a-z]+:\/\/)121media\\.com",
"(^|\\.|[a-z]+:\/\/)icanoptout.com",
"(^|\\.|[a-z]+:\/\/)youcanoptin\\.com",
"(^|\\.|[a-z]+:\/\/)youcanoptin\\.net",
"(^|\\.|[a-z]+:\/\/)youcanoptin\\.org",
"(^|\\.|[a-z]+:\/\/)youcanoptout\\.com",
"(^|\\.|[a-z]+:\/\/)youcanoptout\\.net",
"(^|\\.|[a-z]+:\/\/)youcanoptout\\.org",
"(^|\\.|[a-z]+:\/\/)kidargyle\\.com",  // Chris Cote owned domain
"(^|\\.|[a-z]+:\/\/)maxbonding\\.com", // Chis Cote owned domain
"(^|\\.|[a-z]+:\/\/)server821\\.com"   // Co-hosted with adobur 
   ];
   var arrayOpPortalDomainRegExps = [
"(^|\\.|[a-z]+:\/\/)gozatar\\.com",
"(^|\\.|[a-z]+:\/\/)myclicknet\\.ro",
"(^|\\.|[a-z]+:\/\/)romdiscover\\.com",
"bt\\.webwise\\.com",
"myclicknet\\.romtelecom\\.ro",
"navegador\\.oi\\.com\\.br",
"navegador\\.telefonica\\.com\\.br",
"webwise\\.bt\\.com",
"www\\.bt\\.com\\/webwise"
   ];
   var arrayOCSLabDomainRegExps = [
"(^|\\.|[a-z]+:\/\/)ocslab\\.com",
"(^|\\.|[a-z]+:\/\/)oixcrv-rubyem\\.net",
"(^|\\.|[a-z]+:\/\/)oixcrv-rubytest\\.net",
"(^|\\.|[a-z]+:\/\/)oix-rubyem\\.net",
"(^|\\.|[a-z]+:\/\/)oix-rubytest\\.net",
"(^|\\.|[a-z]+:\/\/)oixssp-rubyem\\.net",
"(^|\\.|[a-z]+:\/\/)rubylan\\.net",
"(^|\\.|[a-z]+:\/\/)rubytag\\.net"
   ];
   var arrayPhormPartnerDomainRegExps = [
"(^|\\.|[a-z]+:\/\/)adex\\.pro",
"(^|\\.|[a-z]+:\/\/)ad-x\\.ru",
"(^|\\.|[a-z]+:\/\/)adhood\\.com",
"(^|\\.|[a-z]+:\/\/)adcash\\.com",
"(^|\\.|[a-z]+:\/\/)youradexchange\\.com",
"(^|\\.|[a-z]+:\/\/)adnxs\\.com",
"(^|\\.|[a-z]+:\/\/)eyereturn\\.com",
"(^|\\.|[a-z]+:\/\/)eyereturnmarketing\\.com",
"(^|\\.|[a-z]+:\/\/)openx\\.net",
"(^|\\.|[a-z]+:\/\/)insomnis-media\\.com",
"(^|\\.|[a-z]+:\/\/)grunderful\\.com", // Paul Grundy owned domain
"(^|\\.|[a-z]+:\/\/)moohww\\.com", // Paul Grundy owned domain
"(^|\\.|[a-z]+:\/\/)dedicatedmedia\\.com",
"(^|\\.|[a-z]+:\/\/)cpadna\\.com", // Dedicated Media
"(^|\\.|[a-z]+:\/\/)cpadna1\\.com", // Dedicated Media
"(^|\\.|[a-z]+:\/\/)trkall\\.com", // Dedicated Media
"(^|\\.|[a-z]+:\/\/)trkthru\\.com", // Dedicated Media
"(^|\\.|[a-z]+:\/\/)nyiax\\.com" // NYIAX, Lou Severine (ex CEO Phluid), Graham Mosley (ex Phorm VP Business Development) 
   ];
   
   var arrayPhormDomainRegExps = [];
   arrayPhormDomainRegExps = arrayOIXDomainRegExps.concat( arrayNonOIXDomainRegExps, arrayOpPortalDomainRegExps, arrayOCSLabDomainRegExps);
dump("Dephormation: Full Domain Array;\n");
dump("Dephormation: \n" + arrayPhormDomainRegExps.toString() );
dump("\n");
   dephormationPhormDomainHostRegExp       = new RegExp(arrayPhormDomainRegExps.join("$|")     + "$", "i");
dump("Dephormation: Full Domain Regexps;\n");
dump("Dephormation: \n" + dephormationPhormDomainHostRegExp.source );
dump("\n");


   dephormationOIXDomainHostRegExp         = new RegExp(arrayOIXDomainRegExps.join("$|")       + "$", "i");
dump("Dephormation: OIX Domain Regexps;\n");
dump("Dephormation: \n" + dephormationOIXDomainHostRegExp.source );
dump("\n");

   dephormationNonOIXDomainHostRegExp      = new RegExp(arrayNonOIXDomainRegExps.join("$|")    + "$", "i");
dump("Dephormation: Non OIX Domain Regexps;\n");
dump("Dephormation: \n" + dephormationNonOIXDomainHostRegExp.source );
dump("\n");

   dephormationOpPortalDomainHostRegExp    = new RegExp(arrayOpPortalDomainRegExps.join("$|")  + "$", "i");
dump("Dephormation: Op Portal Domain Regexps;\n");
dump("Dephormation: \n" + dephormationOpPortalDomainHostRegExp.source );
dump("\n");

   dephormationOCSLabDomainHostRegExp      = new RegExp(arrayOCSLabDomainRegExps.join("$|")    + "$", "i");
dump("Dephormation: OCSLab Domain Regexps;\n");
dump("Dephormation: \n" + dephormationOCSLabDomainHostRegExp.source );
dump("\n");

   dephormationPhormPartnerDomainHostRegExp      = new RegExp(arrayPhormPartnerDomainRegExps.join("$|")    + "$", "i");
dump("Dephormation: Phorm Partner Domain Regexps;\n");
dump("Dephormation: \n" + dephormationPhormPartnerDomainHostRegExp.source );
dump("\n");


   dephormationOIXDomainLinkRegExp         = new RegExp(arrayOIXDomainRegExps.join("\/|")      + "\/", "i");
dump("Dephormation: OIX Domain Link Regexps;\n");
dump("Dephormation: \n" + dephormationOIXDomainLinkRegExp.source );
dump("\n");

   dephormationNonOIXDomainLinkRegExp      = new RegExp(arrayNonOIXDomainRegExps.join("\/|")   + "\/", "i");
dump("Dephormation: Non OIX Domain link Regexps;\n");
dump("Dephormation: \n" + dephormationNonOIXDomainLinkRegExp.source );
dump("\n");

   dephormationOpPortalDomainLinkRegExp    = new RegExp(arrayOpPortalDomainRegExps.join("\/|") + "\/", "i");
dump("Dephormation: Op Portal Domain Link Regexps;\n");
dump("Dephormation: \n" + dephormationOpPortalDomainLinkRegExp.source );
dump("\n");

   dephormationOCSLabDomainLinkRegExp      = new RegExp(arrayOCSLabDomainRegExps.join("\/|")   + "\/", "i");
dump("Dephormation: OCSLab Domain Link Regexps;\n");
dump("Dephormation: \n" + dephormationOCSLabDomainLinkRegExp.source );
dump("\n");

   dephormationPhormPartnerDomainLinkRegExp      = new RegExp(arrayPhormPartnerDomainRegExps.join("\/|")   + "\/", "i");
dump("Dephormation: Phorm Partner Domain Link Regexps;\n");
dump("Dephormation: \n" + dephormationPhormPartnerDomainLinkRegExp.source );
dump("\n");
	
}

// ------------------------------------------------------------------------------------------------
// Mozilla ISODateString (backward compatible)
function ISODateString(d){
  function pad(n){return n<10 ? '0'+n : n}
  return d.getUTCFullYear()+'-'
      + pad(d.getUTCMonth()+1)+'-'
      + pad(d.getUTCDate())+'T'
      + pad(d.getUTCHours())+':'
      + pad(d.getUTCMinutes())+':'
      + pad(d.getUTCSeconds())+'Z'
}

// ------------------------------------------------------------------------------------------------
// log a console error message/warning message
function LogMessage(aMessage) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
  var currentTime  = new Date();
  var MessageTime  = dephormation.strings.getString("LogMessage_DateTime") + " " + ISODateString(currentTime) + "\n";
  var MessageTitle = dephormation.strings.getString("LogMessage_DephormationMessage") + "\n";
  consoleService.logStringMessage( MessageTitle + MessageTime + aMessage);
  logfile_output(MessageTitle + MessageTime + aMessage);
}

// ------------------------------------------------------------------------------------------------
// Dephormation Status Bar/Toolbar Button OnClick Event Handler 
function DephormationOnClickEventHandler(e)
{
    var buttonCode = e.button;

    switch (buttonCode){
      case 0  : // Left button clicked
                openDephormationReport();
                break;
      case 1  : // Middle button clicked
                break;
      case 2  : // Right button clicked
                break;
      default : //alert('Unexpected code: ' + btnCode);
    }
}
// ------------------------------------------------------------------------------------------------
// Show the Dephormation preferences dialog
function openDephormationPrefs(){		
  window.openDialog("chrome://dephormation/content/preferences.xul","Dephormation Prefs","centerscreen, chrome, toolbar, modal");
  dephormation.updateGUIStatus();
}

// ------------------------------------------------------------------------------------------------
// Show the Dephormation report dialog
function openDephormationReport(){		
  var returnValues = { clearReport: false };
  
  window.openDialog("chrome://dephormation/content/report.xul","Dephormation Report","centerscreen, chrome, ,dialog=no, resizable, modal", dephormation.report, returnValues );
  
  if (returnValues.clearReport) {
    dephormation.report = "";
  }
  dephormation.updateGUIStatus();
}

// ------------------------------------------------------------------------------------------------
// Generate a random UID
function RandomUID(length) {
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz_";
	var randomUID = '';
	for (var i=0; i<length; i++) {
		var rnum = Math.floor(Math.random() * chars.length);
		randomUID += chars.substring(rnum,rnum+1);
	}
	return randomUID;
}

// ------------------------------------------------------------------------------------------------
// Search url text for any Phorm domain names
function PhormDomain(searchText) {

	if (dephormationPhormDomainHostRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationPhormDomainHostRegExp);
        if (matches) return matches[0];
	}

    return false;

}
// ------------------------------------------------------------------------------------------------
// Search text for OIX domains
function OIXDomain(searchText) {

	if (dephormationOIXDomainHostRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationOIXDomainHostRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Search text for links to OIX domains
function ContainsLinksToOIXDomain(searchText) {

	if (dephormationOIXDomainLinkRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationOIXDomainLinkRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Search text for Non-OIX Phorm owned domains
function NonOIXDomain(searchText) {

	if (dephormationNonOIXDomainHostRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationNonOIXDomainHostRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Search text for links to Non-OIX Phorm owned domains
function ContainsLinksToNonOIXDomain(searchText) {

	if (dephormationNonOIXDomainLinkRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationNonOIXDomainLinkRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Search text for Phorm hosted operator portal
function OperatorPortalDomain(searchText) {

	if (dephormationOpPortalDomainHostRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationOpPortalDomainHostRegExp);
        if (matches) return matches[0];
	}

    return false;

}


// ------------------------------------------------------------------------------------------------
// Search text for links to Phorm hosted operator portal domains
function ContainsLinksToOperatorPortalDomain(searchText) {

	if (dephormationOpPortalDomainLinkRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationOpPortalDomainLinkRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Search text for OCSLab hosts
function OCSLabDomain(searchText) {

	if (dephormationOCSLabDomainHostRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationOCSLabDomainHostRegExp);
        if (matches) return matches[0];
	}

    return false;

}


// ------------------------------------------------------------------------------------------------
// Search text for links to OCSLab domains
function ContainsLinksToOCSLabDomain(searchText) {

	if (dephormationOCSLabDomainLinkRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationOCSLabDomainLinkRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Search text for Phorm Partner hosts
function PhormPartnerDomain(searchText) {

	if (dephormationPhormPartnerDomainHostRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationPhormPartnerDomainHostRegExp);
        if (matches) return matches[0];
	}

    return false;

}


// ------------------------------------------------------------------------------------------------
// Search text for links to Phorm Partner domains
function ContainsLinksToPhormPartnerDomain(searchText) {

	if (dephormationPhormPartnerDomainLinkRegExp.test(searchText))
	{
        var matches = searchText.match(dephormationPhormPartnerDomainLinkRegExp);
        if (matches) return matches[0];
	}

    return false;

}

// ------------------------------------------------------------------------------------------------
// Dephormation Progress Listener - gives us access to all status changes as the page loads (or redirects occur)

const STATE_START          = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_REDIRECTING    = Components.interfaces.nsIWebProgressListener.STATE_REDIRECTING;
const STATE_TRANSFERRING   = Components.interfaces.nsIWebProgressListener.STATE_TRANSFERRING;
const STATE_NEGOTIATING    = Components.interfaces.nsIWebProgressListener.STATE_NEGOTIATING;
const STATE_STOP           = Components.interfaces.nsIWebProgressListener.STATE_STOP;

const STATE_IS_REQUEST     = Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST;
const STATE_IS_DOCUMENT    = Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT;
const STATE_IS_NETWORK     = Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK;
const STATE_IS_WINDOW      = Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW;

const STATE_RESTORING      = Components.interfaces.nsIWebProgressListener.STATE_RESTORING;

const STATE_IS_INSECURE     = Components.interfaces.nsIWebProgressListener.STATE_IS_INSECURE;
const STATE_IS_BROKEN       = Components.interfaces.nsIWebProgressListener.STATE_IS_BROKEN;
const STATE_IS_SECURE       = Components.interfaces.nsIWebProgressListener.STATE_IS_SECURE;

const STATE_SECURE_HIGH     = Components.interfaces.nsIWebProgressListener.STATE_SECURE_HIGH;
const STATE_SECURE_MED      = Components.interfaces.nsIWebProgressListener.STATE_SECURE_MED;
const STATE_SECURE_LOW      = Components.interfaces.nsIWebProgressListener.STATE_SECURE_LOW;

var dephormationProgressListener = {

// ------------------------------------------------------------------------------------------------
  QueryInterface: function(aIID)
  {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
  },

// ------------------------------------------------------------------------------------------------
  onStateChange: function(aProgress, aRequest, aFlag, aStatus)
  {
   // If you use myListener for more than one tab/window, use
   // aProgress.DOMWindow to obtain the tab/window which triggers the state change

   var ProgressInfo = "";
   var RequestInfo = "";
   var StateInfo = "";
   
   if (aProgress.isLoadingDocument)
   {
      ProgressInfo += dephormation.strings.getString("Progress_LoadingDocument") + "\n";
   }
   else
   {
      ProgressInfo += dephormation.strings.getString("Progress_NotLoadingDocument") + "\n";
   }

   if (aRequest == null)
   {
      RequestInfo += dephormation.strings.getString("Request_Null") + "\n";
   }
   else
   {
      RequestInfo += dephormation.strings.getString("Request_Name") + " " + aRequest.name + "\n";
   }
   
   if (aFlag & STATE_START)
   {  
      StateInfo += dephormation.strings.getString("State_Starting") + "\n";
   } 
   else
   if (aFlag & STATE_REDIRECTING)
   {  
      StateInfo += dephormation.strings.getString("State_Redirecting") + "\n";
   } 
   else
   if (aFlag & STATE_TRANSFERRING)
   {  
      StateInfo += dephormation.strings.getString("State_Transferring") + "\n";
   } 
   else
   if (aFlag & STATE_NEGOTIATING)
   {  
      StateInfo += dephormation.strings.getString("State_Negotiating") + "\n";
   } 
   else
   if (aFlag & STATE_STOP)
   {  
      StateInfo += dephormation.strings.getString("State_Stop") + "\n";
   } 
   
   if (aFlag & STATE_IS_REQUEST)
   {  
      StateInfo += dephormation.strings.getString("State_Request") + "\n";
   } 
   if (aFlag & STATE_IS_DOCUMENT)
   {  
      StateInfo += dephormation.strings.getString("State_Document") + "\n";
   } 
   if (aFlag & STATE_IS_NETWORK)
   {  
      StateInfo += dephormation.strings.getString("State_Network") + "\n";
   } 
   if (aFlag & STATE_IS_WINDOW)
   {  
      StateInfo += dephormation.strings.getString("State_Window") + "\n";
   } 
   if (aFlag & STATE_RESTORING)
   {  
      StateInfo += dephormation.strings.getString("State_Restoring") + "\n";
   } 

   LogMessage( ProgressInfo + RequestInfo + StateInfo );

   return 0;
  },

// ------------------------------------------------------------------------------------------------
  onLocationChange: function(aProgress, aRequest, aURI)
  {
   // This fires when the location bar changes; i.e load event is confirmed
   // or when the user switches tabs. If you use myListener for more than one tab/window,
   // use aProgress.DOMWindow to obtain the tab/window which triggered the change.

   var ProgressInfo = "";
   var RequestInfo = "";
   var LocationChangeInfo = "";

   if (aProgress.isLoadingDocument)
   {
      ProgressInfo += dephormation.strings.getString("Progress_LoadingDocument") + "\n";
   }
   else
   {
      ProgressInfo += dephormation.strings.getString("Progress_NotLoadingDocument") + "\n";
   }

   if (aRequest == null)
   {
      RequestInfo += dephormation.strings.getString("Request_Null") + "\n";
   }
   else
   {
      RequestInfo += dephormation.strings.getString("Request_Name") + " " + aRequest.name + "\n";
   }

   if (aURI == null)
   {
      LocationChangeInfo += dephormation.strings.getString("LocationChange_Null") + "\n";
   }
   else
   {
      LocationChangeInfo += dephormation.strings.getString("LocationChange_URI") + " " + aURI.spec + "\n";;
   }
   
   LogMessage( ProgressInfo + RequestInfo + LocationChangeInfo );

   return 0;
  },

// ------------------------------------------------------------------------------------------------
  onSecurityChange: function(aProgress, aRequest, aFlag)
  {

   var ProgressInfo = "";
   var RequestInfo = "";
   var SecurityInfo = "";

   if (aProgress.isLoadingDocument)
   {
      ProgressInfo += dephormation.strings.getString("Progress_LoadingDocument") + "\n";
   }
   else
   {
      ProgressInfo += dephormation.strings.getString("Progress_NotLoadingDocument") + "\n";
   }

   if (aRequest == null)
   {
      RequestInfo += dephormation.strings.getString("Request_Null") + "\n";
   }
   else
   {
      RequestInfo += dephormation.strings.getString("Request_Name") + " " + aRequest.name + "\n";
   }

   if (aFlag & STATE_IS_INSECURE)
   {  
      SecurityInfo += dephormation.strings.getString("SecurityLevel_Insecure");
   } 
   else
   if (aFlag & STATE_IS_BROKEN)
   {  
      SecurityInfo += dephormation.strings.getString("SecurityLevel_Broken");
   } 
   else
   if (aFlag & STATE_IS_SECURE)
   {  
      if (aFlag & STATE_SECURE_HIGH)
      {  
        SecurityInfo += dephormation.strings.getString("SecurityLevel_SecureHigh");
      } 
      else
      if (aFlag & STATE_SECURE_MED)
      {  
        SecurityInfo += dephormation.strings.getString("SecurityLevel_SecureMed");
      } 
      else
      if (aFlag & STATE_SECURE_LOW)
      {  
        SecurityInfo += dephormation.strings.getString("SecurityLevel_SecureLow");
      } 
   } 

   LogMessage( ProgressInfo + RequestInfo + SecurityInfo );

   return 0;  
  },

// ------------------------------------------------------------------------------------------------
  enable: function() {
      gBrowser.addProgressListener(dephormationProgressListener);
  },

// ------------------------------------------------------------------------------------------------
  disable: function() {
      gBrowser.removeProgressListener(dephormationProgressListener);
  },

// ------------------------------------------------------------------------------------------------
  // For definitions of the remaining functions see XULPlanet.com
  onProgressChange: function() {return 0;},
  onStatusChange: function() {return 0;},
  onLinkIconAvailable: function() {return 0;}
}


// ------------------------------------------------------------------------------------------------
// Dephormation Cookie Listener - gives us access to all cookie changes 

var dephormationCookieListener = {

  observe: function(subject, topic, data) {
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.");

    // Check semphore used to co-ordinate with cookie setting code
    if (preferences.getBoolPref("suppressCookieSettingAlerts")) {
       return;
    }
    
    if (topic == 'cookie-changed') {
      if (data == 'cleared'||data == 'deleted') {
        // cookies removed or cleared from database

      } else if (data == 'changed'||data == 'added' ) {
        // single cookie changed or added
        var cookie = subject.QueryInterface(Components.interfaces.nsICookie2);
        var host   = cookie.host;
        var name   = cookie.name;
        var value  = cookie.value;
        // was the cookie a suspect cookie?
        if(
            (name.search(/webwise/i) > -1) 
        ||  (OIXDomain(host) )
          )
        {
          var CookieWarning = dephormation.strings.getString("Warning_SuspectedPhormOIXTrackingCookie") + "\n\n" + dephormation.strings.getString("Warning_CookieHost") + " = " + host + "\n" + dephormation.strings.getString("Warning_CookieName") + " = " + name + "\n" + dephormation.strings.getString("Warning_CookieValue") + " = " + value + "\n\n" + dephormation.strings.getString("Warning_ISPSpying") ;
          var ShortCookieWarning = dephormation.strings.getString("Warning_PhormDetected");
          var ReportCookieWarning = dephormation.strings.getString("Warning_SuspectedPhormOIXTrackingCookie") + " " + dephormation.strings.getString("Warning_CookieHost") + " = " + host + " " + dephormation.strings.getString("Warning_CookieName") + " = " + name + " " + dephormation.strings.getString("Warning_CookieValue") + " = " + value;
          
          dephormation.updateGUIStatus(ShortCookieWarning, CookieWarning, "chrome://dephormation/skin/redflag.gif", "color:#ff0000; font-weight:bold;");

          LogMessage( CookieWarning ); 
          
          dephormation.addReportEntry( ReportCookieWarning );

          if (preferences.getBoolPref("showCookieSettingAlert")) {
          
		     try {
			   var notificationBox = gBrowser.getNotificationBox();
			   notificationBox.appendNotification (CookieWarning, "DephormationWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_CRITICAL_HIGH, null);
		     }
		     catch(err) {
			   // ignore, support for alerts in Firefox is a bit erratic
		     }

		     if (!dephormationAlertShownFlag)
		     {
			     try {
                    var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
						  .getService(Components.interfaces.nsIAlertsService);
                    alertsService.showAlertNotification(  "chrome://dephormation/skin/redflag_large.gif", "Dephormation", ShortCookieWarning );
			     }
			     catch(err) {
				   // use a javascript alert, support for alerts in Firefox is a bit erratic
				   alert( CookieWarning );
			     }
			     dephormationAlertShownFlag = true;
             }
          } // if showcookiesettingalert
        }
      }
    }
  },

// ------------------------------------------------------------------------------------------------
  enable: function() {
    // Add cookie listener
      var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

      try {
         observerService.addObserver( dephormationCookieListener, 'cookie-changed', false);
      }
      catch(err) {
         dump(err.message);
      }
  },

// ------------------------------------------------------------------------------------------------
  disable: function() {
    // Remove Cookie listener
      var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

      try {
         observerService.removeObserver( dephormationCookieListener, 'cookie-changed');
      }
      catch(err) {
         dump(err.message);
      }
  }

}




// ------------------------------------------------------------------------------------------------
// Dephormation HTTP Observer - Called as a http request is made. 


var dephormationHTTPObserver = {

  observe: function(subject, topic, data) {
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.");

    if (topic == "http-on-modify-request") {
       var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);

       if (PhormDomain(httpChannel.URI.host))
       {
          var FlashLSORegExp = new RegExp(/memo.*[.]swf/);
          if (FlashLSORegExp.test(subject.URI.spec))
             var PhormContentType = dephormation.strings.getString("Warning_FlashLSO");
          else
             var PhormContentType = dephormation.strings.getString("Warning_PhormContentRequest");

          var PhormWarning = PhormContentType + "\n\n" + dephormation.strings.getString("Warning_ISPSpying")+ "\n\n" + subject.URI.spec;
          var ShortPhormWarning = dephormation.strings.getString("Warning_PhormDetected") ;
          var ReportPhormWarning = PhormContentType + " " + subject.URI.spec;

          dephormation.updateGUIStatus(ShortPhormWarning, PhormWarning, "chrome://dephormation/skin/redflag.gif", "color:#ff0000; font-weight:bold;");
          
          LogMessage( PhormWarning );
          
          dephormation.addReportEntry( ReportPhormWarning );
       
          if (
              (preferences.getBoolPref("showOIXDomainAlert")            && OIXDomain(httpChannel.URI.host))
           || (preferences.getBoolPref("showNonOIXDomainAlert")         && NonOIXDomain(httpChannel.URI.host))
           || (preferences.getBoolPref("showOperatorPortalDomainAlert") && OperatorPortalDomain(httpChannel.URI.host))
           || (preferences.getBoolPref("showOCSLabDomainAlert")         && OCSLabDomain(httpChannel.URI.host))
          ) {
             try {
                var notificationBox = gBrowser.getNotificationBox();
                notificationBox.appendNotification (PhormWarning, "DephormationWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_CRITICAL_HIGH, null);
             }
             catch(err) {
               // ignore, support for alerts in Firefox is a bit erratic
             }
             if (!dephormationAlertShownFlag)
		     {
                try {
                   var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                        .getService(Components.interfaces.nsIAlertsService);
                   alertsService.showAlertNotification(  "chrome://dephormation/skin/redflag_large.gif", "Dephormation", ShortPhormWarning );
                }
                catch(err) {
                   // use a javascript alert, support for alerts in Firefox is a bit erratic
                   alert( PhormWarning );
                }
		        dephormationAlertShownFlag = true;
             }
          } // if show###DomainAlert
       }
       if (preferences.getBoolPref("blockOIXDomainRequest") && PhormDomain(httpChannel.URI.host))
       {
          httpChannel.cancel(Components.results.NS_ERROR_CONNECTION_REFUSED);

          var BlockWarning = dephormation.strings.getString("Warning_PhormBlocked") + "\n\n" + dephormation.strings.getString("Warning_ISPSpying")+ "\n\n" + subject.URI.spec;
          var ShortBlockWarning = dephormation.strings.getString("Warning_PhormDetected") ;
          var ReportBlockWarning = dephormation.strings.getString("Warning_PhormBlocked") + " " + subject.URI.spec;

          dephormation.updateGUIStatus( ShortBlockWarning, BlockWarning, "chrome://dephormation/skin/redflag.gif", "color:#ff0000; font-weight:bold;");

          LogMessage( BlockWarning );  
          
          dephormation.addReportEntry( ReportBlockWarning );
          
          if (preferences.getBoolPref("showCookieSettingAlert")) {  
          
             try {
                var notificationBox = gBrowser.getNotificationBox();
                notificationBox.appendNotification (BlockWarning, "DephormationWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_CRITICAL_HIGH, null);
             }
             catch(err) {
                // ignore, support for alerts in Firefox is a bit erratic
             }
		     if (!dephormationAlertShownFlag)
		     {
                try {
                   var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                       .getService(Components.interfaces.nsIAlertsService);
                   alertsService.showAlertNotification(  "chrome://dephormation/skin/redflag_large.gif", "Dephormation", ShortBlockWarning );
                }
                catch(err) {
                   // use a javascript alert, support for alerts in Firefox is a bit erratic
                   alert( BlockWarning );
                }
			    dephormationAlertShownFlag = true;
             }
          } // if showcookiesettingalert
       }
       if (preferences.getBoolPref("blockPhormPartners") && PhormPartnerDomain(httpChannel.URI.host))
       {
          httpChannel.cancel(Components.results.NS_ERROR_CONNECTION_REFUSED);          

          var BlockWarning = dephormation.strings.getString("Warning_PhormPartnerBlocked") + " " + httpChannel.URI.host;

          try {
             var notificationBox = gBrowser.getNotificationBox();
             notificationBox.appendNotification (BlockWarning, "DephormationWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_WARNING_LOW, null);
          }
          catch(err) {
             // ignore, support for alerts in Firefox is a bit erratic
          }
          dump("Dephormation blocked a Phorm partner domain request\n");
       }
    } else
    if (topic == "http-on-examine-response") {
       var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);

       // Is the response a redirect?
       if ( (httpChannel.responseStatus==301) || (httpChannel.responseStatus==302) || (httpChannel.responseStatus==303) || (httpChannel.responseStatus==307))
       {
          // Location of the redirect
          var redirectLocation = httpChannel.getResponseHeader("Location");
          var redirectHost = redirectLocation;
          // Remove protocol:// if present
          if( redirectHost.indexOf("://", 0) > -1 )
              redirectHost = redirectHost.substr(redirectHost.indexOf("://", 0)+3);
          // Remove anything after / if present
          if( redirectHost.indexOf("/", 0) > -1 )
              redirectHost = redirectHost.slice(0,redirectHost.indexOf("/", 0));

          // If the original URL was not OIX or Phorm or an operator portal, but the redirect location is...
          if ( (!PhormDomain(httpChannel.URI.host)) && (PhormDomain(redirectHost)) ) 
          {
             var HijackWarning = dephormation.strings.getString("Warning_PhormHijackedRequest")+ "\n\n" + dephormation.strings.getString("Warning_ISPSpying")+ "\n\n" + subject.URI.spec + " " + dephormation.strings.getString("Warning_RedirectedTo") + " " + redirectLocation + "\n" + dephormation.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " +  dephormation.strings.getString("Warning_RedirectMessage");
             var ShortHijackWarning = dephormation.strings.getString("Warning_PhormDetected") ;
             var ReportHijackWarning = dephormation.strings.getString("Warning_PhormHijackedRequest") + " " + subject.URI.spec + " " + dephormation.strings.getString("Warning_RedirectedTo") + " " + redirectLocation  + " " + dephormation.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " +  dephormation.strings.getString("Warning_RedirectMessage");

             dephormation.updateGUIStatus( ShortHijackWarning, HijackWarning, "chrome://dephormation/skin/redflag.gif", "color:#ff0000; font-weight:bold;");

             LogMessage( HijackWarning );
                
             dephormation.addReportEntry( ReportHijackWarning );

             if (preferences.getBoolPref("showCookieSettingAlert")) {           
             
                try {
                   var notificationBox = gBrowser.getNotificationBox();
                   notificationBox.appendNotification (HijackWarning, "DephormationWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_CRITICAL_HIGH, null);
                }
                catch(err) {
                  // ignore, support for alerts in Firefox is a bit erratic
                }
                if (!dephormationAlertShownFlag)
		        {
					try {
					   var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
							.getService(Components.interfaces.nsIAlertsService);
					   alertsService.showAlertNotification(  "chrome://dephormation/skin/redflag_large.gif", "Dephormation", ShortHijackWarning );
					}
					catch(err) {
					   alert( HijackWarning );
					}
					dephormationAlertShownFlag=true;
				}
             } // if showcookiesettingalert

             if (preferences.getBoolPref("spikeOIXRedirect"))
             {
                // spike the redirect
                var spikeOIXRedirectLocation = preferences.getCharPref("spikeOIXRedirectLocation");
                httpChannel.setResponseHeader("Location", spikeOIXRedirectLocation, false);
             
                var SpikeWarning = dephormation.strings.getString("Warning_SpikedPhormHijackedRequest") + "\n\n" + dephormation.strings.getString("Warning_ISPSpying")+ "\n\n" + subject.URI.spec + " " + dephormation.strings.getString("Warning_RedirectedTo") + " " + redirectLocation + "\n" + dephormation.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " +  dephormation.strings.getString("Warning_RedirectMessage");
                var ShortSpikeWarning = dephormation.strings.getString("Warning_PhormSpiked") ;
                var ReportSpikeWarning = dephormation.strings.getString("Warning_SpikedPhormHijackedRequest") + " "  + subject.URI.spec + " " + dephormation.strings.getString("Warning_RedirectedTo") + " " + redirectLocation + " " + dephormation.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " +  dephormation.strings.getString("Warning_RedirectMessage");

                dephormation.updateGUIStatus(ShortSpikeWarning, SpikeWarning, "chrome://dephormation/skin/redflag.gif", "color:#ff0000; font-weight:bold;");

                LogMessage( SpikeWarning );  
                
                dephormation.addReportEntry( ReportSpikeWarning );
                
                if (preferences.getBoolPref("showCookieSettingAlert")) {           
             
                   try {
                      var notificationBox = gBrowser.getNotificationBox();
                      notificationBox.appendNotification (SpikeWarning, "DephormationWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_CRITICAL_HIGH, null);
                   }
                   catch(err) {
                     // ignore, support for alerts in Firefox is a bit erratic
                   }
                   if (!dephormationAlertShownFlag)
		           {
                      try {
                         var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
							.getService(Components.interfaces.nsIAlertsService);
                         alertsService.showAlertNotification(  "chrome://dephormation/skin/redflag_large.gif", "Dephormation", ShortSpikeWarning );
                      }
                      catch(err) {
                         // do nothing
                      }
                      dephormationAlertShownFlag=true;
                   }
				} // if showcookiesettingalert
             }
          }
       }
    }
  },

// ------------------------------------------------------------------------------------------------
  enable: function() {
     // Add HTTP Observer
     var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

     try {
        observerService.addObserver(dephormationHTTPObserver, "http-on-modify-request", false);
        observerService.addObserver(dephormationHTTPObserver, "http-on-examine-response", false);
     }
     catch(err) {
        dump(err.message);
     }
   },

// ------------------------------------------------------------------------------------------------
  disable: function() {
     // Remove HTTP Observer
     var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

     try {
        observerService.removeObserver(dephormationHTTPObserver, "http-on-modify-request");
        observerService.removeObserver(dephormationHTTPObserver, "http-on-examine-response");
     }
     catch(err) {
        dump(err.message);
     }
  }


}





// ------------------------------------------------------------------------------------------------
// Dephormation Add On - the work horse of the browser add on. Checks page for links, sets cookies


var dephormation = {

  report:    "",
  
  //----------------------------------------------------------------------------------------------------
  init: function() {
    dump("Dephormation: initialising\n");

    // Add initialise reg exp strings
    dump("Dephormation: initialising reg exps\n");
    initialiseRegExps();
	
    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.");

    this.strings = document.getElementById("dephormation-strings");

    if (preferences.getBoolPref("showStartupAlert"))
    {
		dump("Dephormation displaying splash screen\n");
		window.openDialog("chrome://dephormation/content/splash.xul","Dephormation Installed","centerscreen, chrome, toolbar, modal");
    }

    dump("Dephormation: adding pageload listeners\n");

    var appcontent = document.getElementById("appcontent");   // browser
    if(appcontent)
      appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, true);

    // Add progress listener
    dump("Dephormation: enabling request progress listener\n");
    dephormationProgressListener.enable(); 

    // Add cookie listener
    dump("Dephormation: enabling cookie listener\n");
    dephormationCookieListener.enable();

    // Add http observer
    dump("Dephormation: initialising HTTP observer\n");
    dephormationHTTPObserver.enable();

    // Initialise the Flash LSO path
    dump("Dephormation: initialising Flash LSO path preference\n");
    initialiseFlashLSOPath();
    
    // Initialise the Browser Activity path
    dump("Dephormation: initialising browser activity log path preference\n");
    initialiseBrowserActivityLogPath();

    // Initialise the status bar
    dump("Dephormation: initialising gui status in toolbar/status bar\n");
    dephormation.updateGUIStatus();

    // SET COOKIES
    dump("Dephormation: initialising Dephormed cookies\n");
    this.SetPhormCookies();

    // REWRITE FLASH LSOs
    dump("Dephormation: initialising Dephormed LSOs\n");
    this.RewritePhormFlashLSO();

    dump("Dephormation: Phorm cookie suppression loaded!\n");

  },

  //----------------------------------------------------------------------------------------------------
  uninit: function() {
    dump("Dephormation: uninitialising\n");
    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.");

    dump("Dephormation: removing request progress listener\n");

    // Remove progress listener
    dephormationProgressListener.disable(); 

    dump("Dephormation: removing cookie listener\n");

    // Remove Cookie listener
    dephormationCookieListener.disable();

    dump("Dephormation: removing http observer\n");

    // Remove http listener
    dephormationHTTPObserver.disable();

  },

  //----------------------------------------------------------------------------------------------------
  onPageLoad: function(e) {
    dump("Dephormation: OnPageLoad called\n");

	dephormationAlertShownFlag = false;
	
    var doc = e.originalTarget; // document that triggered "onload" event

    // LOG COOKIE DETAILS FOR CURRENT LOCATION
    dump("Dephormation: OnPageLoad logging cookies set for present domain\n");
    dephormation.LogCookieDetailsForPage(doc);

    // SET COOKIES
    dump("Dephormation: OnPageLoad setting Dephormed cookies\n");
    dephormation.SetPhormCookies();

    // REWRITE FLASH LSOs
    dump("Dephormation: OnPageLoad writing Dephormed LSOs\n");
    dephormation.RewritePhormFlashLSO();

    // SEARCH FOR LINKS TO PHORM/OIX DOMAINS
    dump("Dephormation: OnPageLoad searching for Phorm links in URL and page\n");
    dephormation.SearchForPhormLinks(doc);

    dump("Dephormation: OnPageLoad finished page processing\n");
    window.status= dephormation.strings.getString("StatusFinishedProcessing");

  }, // end on page load


  //----------------------------------------------------------------------------------------------------
  LogCookieDetailsForPage: function(doc) {
    var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService();
	cookieManager = cookieManager.QueryInterface(Components.interfaces.nsICookieManager);

    var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService().QueryInterface(Components.interfaces.nsICookieService);

    var uriDocumentURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uriDocumentURI.spec = doc.location; 

    LogMessage( dephormation.strings.getString("LogCookieDetailsForPage_CurrentLocation") + " " + doc.location + "\n" + dephormation.strings.getString("CurrentCookies") + " " + cookieService.getCookieString( uriDocumentURI, null ) );
  }, // LogCookieDetailsForPage

  //----------------------------------------------------------------------------------------------------
  // Search URL and page text for references to Phorm domains.
  SearchForPhormLinks: function(doc) {
    dump("Dephormation: Searching for Phorm links in URL and page\n");

    var uriDocumentURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uriDocumentURI.spec = doc.location; 

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.");

    var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService();
	cookieManager = cookieManager.QueryInterface(Components.interfaces.nsICookieManager);

    var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService().QueryInterface(Components.interfaces.nsICookieService);

    try{
      // Get the notification box for notifications
      var targetBrowser = gBrowser.getBrowserForDocument(doc);
      var notificationBox = gBrowser.getNotificationBox(targetBrowser);
    }
    catch (err) {
       // ignore, support for notifications in Firefox is a bit erratic
    }

    // Concatenate PAGE URL AND PAGE TEXT
    var stringSearchTarget = "";
    if (doc.location)
    {
       if (doc.location.href)
       {
          stringSearchTarget += doc.location.href;
       }
    }
    if (doc.body)
    {
       if (doc.body.innerHTML)
       {
          stringSearchTarget += " " + doc.body.innerHTML;
       }
    }
    dump(stringSearchTarget.substring(0,99));
    dump("... (first hundred characters)\n");

    var stringNotificationMessage = "";
    var stringLinkMatch = false;

    // SEARCH PAGE URL AND PAGE TEXT FOR REFERENCES TO PHORM OIX ADVERTISING DOMAINS 
    if (preferences.getBoolPref("showOIXDomainAlert"))
    {
        dump("Dephormation: searching for Phorm OIX Webwise domains\n");
        window.status= dephormation.strings.getString("StatusSearchingForPhormOIXWebwiseDomains");

		stringLinkMatch = ContainsLinksToOIXDomain(stringSearchTarget);
        if(stringLinkMatch)
        {
          stringNotificationMessage= dephormation.strings.getString("OIXDomainWarning") + " (" + stringLinkMatch + ")";
          try{
            notificationBox.appendNotification(stringNotificationMessage, "OIXDomainWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_WARNING_HIGH, null);
          }
          catch (err) {
            // use standard alert, support for notifications in Firefox is a bit erratic
            alert(stringNotificationMessage);
          }
        }
    }


    // SEARCH PAGE URL AND PAGE TEXT FOR REFERENCES TO OPERATOR PORTAL DOMAINS USED BY PHORM
    if (preferences.getBoolPref("showOperatorPortalDomainAlert"))
    {
        dump("Dephormation: searching for Phorm hosted operator portal domains\n");
        window.status= dephormation.strings.getString("StatusSearchingForOperatorPortalDomains");

        stringLinkMatch = ContainsLinksToOperatorPortalDomain(stringSearchTarget);
        if(stringLinkMatch)
        {
          stringNotificationMessage = dephormation.strings.getString("OperatorPortalDomainWarning") + " (" + stringLinkMatch + ")";
          try{
            notificationBox.appendNotification(stringNotificationMessage, "OperatorPortalDomainWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_WARNING_MEDIUM, null);
          }
          catch (err) {
            // use standard alert, support for notifications in Firefox is a bit erratic
            alert(stringNotificationMessage);
          }
        }
    }

    // SEARCH PAGE URL AND PAGE TEXT FOR REFERENCES TO OTHER PHORM OWNED DOMAINS
    if (preferences.getBoolPref("showNonOIXDomainAlert"))
    {
        dump("Dephormation: searching for other Phorm domains\n");
        window.status= dephormation.strings.getString("StatusSearchingForOtherPhormDomains");

        stringLinkMatch = ContainsLinksToNonOIXDomain(stringSearchTarget);
        if(stringLinkMatch)
        {
          stringNotificationMessage = dephormation.strings.getString("NonOIXDomainWarning") + " (" + stringLinkMatch + ")";
          try{
            notificationBox.appendNotification (stringNotificationMessage, "NonOIXDomainWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_WARNING_LOW, null);
          }
          catch (err) {
            // use standard alert, support for notifications in Firefox is a bit erratic
            alert(stringNotificationMessage);
          }
        }
    }

    // SEARCH PAGE URL AND PAGE TEXT FOR REFERENCES TO OCSLab OWNED DOMAINS
    if (preferences.getBoolPref("showOCSLabDomainAlert"))
    {
        dump("Dephormation: searching for OCSLab domains\n");
        window.status= dephormation.strings.getString("StatusSearchingForOCSLabDomains");

        stringLinkMatch = ContainsLinksToOCSLabDomain(stringSearchTarget);
        if(stringLinkMatch)
        {
          stringNotificationMessage = dephormation.strings.getString("OCSLabDomainWarning") + " (" + stringLinkMatch + ")";
          try{
            notificationBox.appendNotification (stringNotificationMessage, "OCSLabDomainWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_WARNING_LOW, null);
          }
          catch (err) {
            // use standard alert, support for notifications in Firefox is a bit erratic
            alert(stringNotificationMessage);
          }
        }
    }

    // SEARCH PAGE URL AND PAGE TEXT FOR REFERENCES TO PHORM PARTNER OWNED DOMAINS
    if (preferences.getBoolPref("showPhormPartnerDomainAlert"))
    {
        dump("Dephormation: searching for Phorm Partner domains\n");
        window.status= dephormation.strings.getString("StatusSearchingForPhormPartnerDomains");

        stringLinkMatch = ContainsLinksToPhormPartnerDomain(stringSearchTarget);
        if(stringLinkMatch)
        {
          stringNotificationMessage = dephormation.strings.getString("PhormPartnerDomainWarning") + " (" + stringLinkMatch + ")";
          try{
            notificationBox.appendNotification (stringNotificationMessage, "PhormPartnerDomainWarning", "chrome://dephormation/skin/blueflag.gif", notificationBox.PRIORITY_WARNING_LOW, null);
          }
          catch (err) {
            // use standard alert, support for notifications in Firefox is a bit erratic
            alert(stringNotificationMessage);
          }
        }
    }

    dump("Dephormation: Finished searching for Phorm links\n");

   }, // End SearchForPhormLinks

  //----------------------------------------------------------------------------------------------------
  SetPhormCookies: function() {
    dump("Dephormation: SetPhormCookies setting opt out cookies\n");

    // DISABLE PHORM - SET OPT OUT COOKIES 
    this.SetPhormUKOptOutCookies();
    this.SetPhormBROptOutCookies();
    this.SetPhormTRGezintiOptOutCookies();
    this.SetPhormTRAdoburOptOutCookies();
    this.SetPhormCNMooDooOptOutCookies();
    this.SetPhormCNFengFengTieOptOutCookies();
    this.SetPhormCNGenniOptOutCookies();
    this.SetPhormRUIMRKOptOutCookies();
    this.SetPhorm__FideoOptOutCookies();
    this.SetPhorm__PhluidMediaOptOutCookies();
    this.SetPhorm__MooDooCNOptOutCookies();

    dump("Dephormation: SetPhormCookies setting uid cookies\n");

    // RANDOMIZE PHORM UID COOKIES
    this.SetPhormUKUIDCookies();
    this.SetPhormBRUIDCookies();
    this.SetPhormTRGezintiUIDCookies();
    this.SetPhormTRAdoburUIDCookies();
    this.SetPhormCNMooDooUIDCookies();
    this.SetPhormCNFengFengTieUIDCookies();
    this.SetPhormCNGenniUIDCookies();
    this.SetPhormRUIMRKUIDCookies();
    this.SetPhorm__FideoUIDCookies();
    this.SetPhorm__PhluidMediaUIDCookies();
    this.SetPhorm__MooDooCNUIDCookies();

    dump("Dephormation: SetPhormCookies cookie setting complete\n");

  }, // end SetPhormCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormUKOptOutCookies: function() {
    dump("Dephormation: SetPhormUKOptOutCookies setting UK opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm UK Optout cookies

    var stringPhormUKOptOutCookieName     = this.strings.getString("PhormUKOptOutCookieName");
    var stringPhormUKOptOutCookieValue    = this.strings.getString("PhormUKOptOutCookieValue");
    var stringPhormUKOptOutCookieProtocol = this.strings.getString("PhormUKOptOutCookieProtocol");
    var stringPhormUKOptOutCookiePath     = this.strings.getString("PhormUKOptOutCookiePath");
    var stringPhormUKOptOutCookieDomain   = this.strings.getString("PhormUKOptOutCookieDomain");

    this.OverwriteCookie( stringPhormUKOptOutCookieName, stringPhormUKOptOutCookieValue, stringPhormUKOptOutCookieProtocol,
        stringPhormUKOptOutCookiePath, stringPhormUKOptOutCookieDomain);      

    dump("Dephormation: SetPhormUKOptOutCookies erasing UK UID cookies\n");

    // Erase Phorm UK UID cookies

    var stringPhormUKUIDCookieName       = this.strings.getString("PhormUKUIDCookieName");
    var stringPhormUKUIDCookieProtocol   = this.strings.getString("PhormUKUIDCookieProtocol");
    var stringPhormUKUIDCookiePath       = this.strings.getString("PhormUKUIDCookiePath");
    var stringPhormUKUIDCookieDomain     = this.strings.getString("PhormUKUIDCookieDomain");

    this.DeleteCookie(stringPhormUKUIDCookieName, stringPhormUKUIDCookieProtocol, stringPhormUKUIDCookiePath, stringPhormUKUIDCookieDomain);

  }, // end SetPhormUKOptOutCookies


  //----------------------------------------------------------------------------------------------------
  SetPhormUKUIDCookies: function() {
    dump("Dephormation: SetPhormUKUIDCookies randomising Phorm UK UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm UK cookies

    var stringPhormUKUIDCookieName     = this.strings.getString("PhormUKUIDCookieName");
    //var stringPhormUKUIDCookieValue    = this.strings.getString("PhormUKUIDCookieValue");
    var stringPhormUKUIDCookieProtocol = this.strings.getString("PhormUKUIDCookieProtocol");
    var stringPhormUKUIDCookiePath     = this.strings.getString("PhormUKUIDCookiePath");
    var stringPhormUKUIDCookieDomain   = this.strings.getString("PhormUKUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormUKUIDCookieValue = RandomUID(22) + "||";

    this.OverwriteCookie( stringPhormUKUIDCookieName, stringPhormUKUIDCookieValue, stringPhormUKUIDCookieProtocol,
        stringPhormUKUIDCookiePath, stringPhormUKUIDCookieDomain);      

  }, // end SetPhormUKUIDCookies


  //----------------------------------------------------------------------------------------------------
  SetPhormBROptOutCookies: function() {
    dump("Dephormation: SetPhormBROptOutCookies setting BR opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm BR Optout cookies

    var stringPhormBROptOutCookieName     = this.strings.getString("PhormBROptOutCookieName");
    var stringPhormBROptOutCookieValue    = this.strings.getString("PhormBROptOutCookieValue");
    var stringPhormBROptOutCookieProtocol = this.strings.getString("PhormBROptOutCookieProtocol");
    var stringPhormBROptOutCookiePath     = this.strings.getString("PhormBROptOutCookiePath");
    var stringPhormBROptOutCookieDomain   = this.strings.getString("PhormBROptOutCookieDomain");

    this.OverwriteCookie( stringPhormBROptOutCookieName, stringPhormBROptOutCookieValue, stringPhormBROptOutCookieProtocol,
        stringPhormBROptOutCookiePath, stringPhormBROptOutCookieDomain);      

    dump("Dephormation: SetPhormBROptOutCookies erasing BR opt in cookies\n");

    // Erase Phorm BR Opt In cookies

    var stringPhormBROptInCookieName     = this.strings.getString("PhormBROptInCookieName");
    var stringPhormBROptInCookieProtocol = this.strings.getString("PhormBROptInCookieProtocol");
    var stringPhormBROptInCookiePath     = this.strings.getString("PhormBROptInCookiePath");
    var stringPhormBROptInCookieDomain   = this.strings.getString("PhormBROptInCookieDomain");

    this.DeleteCookie(stringPhormBROptInCookieName, stringPhormBROptInCookieProtocol, stringPhormBROptInCookiePath, stringPhormBROptInCookieDomain);

    dump("Dephormation: SetPhormBROptOutCookies erasing BR UID cookies\n");

    // Erase Phorm BR UID cookies

    var stringPhormBRUIDCookieName       = this.strings.getString("PhormBRUIDCookieName");
    var stringPhormBRUIDCookieProtocol   = this.strings.getString("PhormBRUIDCookieProtocol");
    var stringPhormBRUIDCookiePath       = this.strings.getString("PhormBRUIDCookiePath");
    var stringPhormBRUIDCookieDomain     = this.strings.getString("PhormBRUIDCookieDomain");

    this.DeleteCookie(stringPhormBRUIDCookieName, stringPhormBRUIDCookieProtocol, stringPhormBRUIDCookiePath, stringPhormBRUIDCookieDomain);

  }, // end SetPhormBROptOutCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormBRUIDCookies: function() {
    dump("Dephormation: SetPhormBRUIDCookies randomising Phorm BR UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm BR cookies

    var stringPhormBRUIDCookieName       = this.strings.getString("PhormBRUIDCookieName");
    //var stringPhormBRUIDCookieValue      = this.strings.getString("PhormBRUIDCookieValue");
    var stringPhormBRUIDCookieProtocol   = this.strings.getString("PhormBRUIDCookieProtocol");
    var stringPhormBRUIDCookiePath       = this.strings.getString("PhormBRUIDCookiePath");
    var stringPhormBRUIDCookieDomain     = this.strings.getString("PhormBRUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormBRUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormBRUIDCookieName, stringPhormBRUIDCookieValue, stringPhormBRUIDCookieProtocol,
        stringPhormBRUIDCookiePath, stringPhormBRUIDCookieDomain);      

  }, // end SetPhormBRUIDCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormTRGezintiOptOutCookies: function() {
    dump("Dephormation: SetPhormTRGezintiOptOutCookies setting TR opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm TR Optout cookies

    var stringPhormTRGezintiOptOutCookieName     = this.strings.getString("PhormTRGezintiOptOutCookieName");
    var stringPhormTRGezintiOptOutCookieValue    = this.strings.getString("PhormTRGezintiOptOutCookieValue");
    var stringPhormTRGezintiOptOutCookieProtocol = this.strings.getString("PhormTRGezintiOptOutCookieProtocol");
    var stringPhormTRGezintiOptOutCookiePath     = this.strings.getString("PhormTRGezintiOptOutCookiePath");
    var stringPhormTRGezintiOptOutCookieDomain   = this.strings.getString("PhormTRGezintiOptOutCookieDomain");

    this.OverwriteCookie( stringPhormTRGezintiOptOutCookieName, stringPhormTRGezintiOptOutCookieValue, stringPhormTRGezintiOptOutCookieProtocol,
        stringPhormTRGezintiOptOutCookiePath, stringPhormTRGezintiOptOutCookieDomain);      

    dump("Dephormation: SetPhormTRGezintiOptOutCookies erasing TR opt in cookies\n");

    // Erase Phorm TR Opt In cookies

    var stringPhormTRGezintiOptInCookieName     = this.strings.getString("PhormTRGezintiOptInCookieName");
    var stringPhormTRGezintiOptInCookieProtocol = this.strings.getString("PhormTRGezintiOptInCookieProtocol");
    var stringPhormTRGezintiOptInCookiePath     = this.strings.getString("PhormTRGezintiOptInCookiePath");
    var stringPhormTRGezintiOptInCookieDomain   = this.strings.getString("PhormTRGezintiOptInCookieDomain");

    this.DeleteCookie(stringPhormTRGezintiOptInCookieName, stringPhormTRGezintiOptInCookieProtocol, stringPhormTRGezintiOptInCookiePath, stringPhormTRGezintiOptInCookieDomain);

    dump("Dephormation: SetPhormTRGezintiOptOutCookies erasing TR UID cookies\n");

    // Erase Phorm TR UID cookies

    var stringPhormTRGezintiUIDCookieName       = this.strings.getString("PhormTRGezintiUIDCookieName");
    var stringPhormTRGezintiUIDCookieProtocol   = this.strings.getString("PhormTRGezintiUIDCookieProtocol");
    var stringPhormTRGezintiUIDCookiePath       = this.strings.getString("PhormTRGezintiUIDCookiePath");
    var stringPhormTRGezintiUIDCookieDomain     = this.strings.getString("PhormTRGezintiUIDCookieDomain");

    this.DeleteCookie(stringPhormTRGezintiUIDCookieName, stringPhormTRGezintiUIDCookieProtocol, stringPhormTRGezintiUIDCookiePath, stringPhormTRGezintiUIDCookieDomain);

  }, // end SetPhormTRGezintiOptOutCookies

 
  //----------------------------------------------------------------------------------------------------
  SetPhormTRGezintiUIDCookies: function() {
    dump("Dephormation: SetPhormTRGezintiUIDCookies randomising Phorm TR UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm BR cookies

    var stringPhormTRGezintiUIDCookieName       = this.strings.getString("PhormTRGezintiUIDCookieName");
    //var stringPhormTRGezintiUIDCookieValue      = this.strings.getString("PhormTRGezintiUIDCookieValue");
    var stringPhormTRGezintiUIDCookieProtocol   = this.strings.getString("PhormTRGezintiUIDCookieProtocol");
    var stringPhormTRGezintiUIDCookiePath       = this.strings.getString("PhormTRGezintiUIDCookiePath");
    var stringPhormTRGezintiUIDCookieDomain     = this.strings.getString("PhormTRGezintiUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormTRGezintiUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormTRGezintiUIDCookieName, stringPhormTRGezintiUIDCookieValue, stringPhormTRGezintiUIDCookieProtocol,
        stringPhormTRGezintiUIDCookiePath, stringPhormTRGezintiUIDCookieDomain);      

  }, // end SetPhormTRGezintiUIDCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormTRAdoburOptOutCookies: function() {
    dump("Dephormation: SetPhormTRAdoburOptOutCookies setting TR opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm TR Optout cookies

    var stringPhormTRAdoburOptOutCookieName     = this.strings.getString("PhormTRAdoburOptOutCookieName");
    var stringPhormTRAdoburOptOutCookieValue    = this.strings.getString("PhormTRAdoburOptOutCookieValue");
    var stringPhormTRAdoburOptOutCookieProtocol = this.strings.getString("PhormTRAdoburOptOutCookieProtocol");
    var stringPhormTRAdoburOptOutCookiePath     = this.strings.getString("PhormTRAdoburOptOutCookiePath");
    var stringPhormTRAdoburOptOutCookieDomain   = this.strings.getString("PhormTRAdoburOptOutCookieDomain");

    this.OverwriteCookie( stringPhormTRAdoburOptOutCookieName, stringPhormTRAdoburOptOutCookieValue, stringPhormTRAdoburOptOutCookieProtocol,
        stringPhormTRAdoburOptOutCookiePath, stringPhormTRAdoburOptOutCookieDomain);      

    dump("Dephormation: SetPhormTRAdoburOptOutCookies erasing TR opt in cookies\n");

    // Erase Phorm TR Opt In cookies

    var stringPhormTRAdoburOptInCookieName     = this.strings.getString("PhormTRAdoburOptInCookieName");
    var stringPhormTRAdoburOptInCookieProtocol = this.strings.getString("PhormTRAdoburOptInCookieProtocol");
    var stringPhormTRAdoburOptInCookiePath     = this.strings.getString("PhormTRAdoburOptInCookiePath");
    var stringPhormTRAdoburOptInCookieDomain   = this.strings.getString("PhormTRAdoburOptInCookieDomain");

    this.DeleteCookie(stringPhormTRAdoburOptInCookieName, stringPhormTRAdoburOptInCookieProtocol, stringPhormTRAdoburOptInCookiePath, stringPhormTRAdoburOptInCookieDomain);

    dump("Dephormation: SetPhormTRAdoburOptOutCookies erasing TR UID cookies\n");

    // Erase Phorm TR UID cookies

    var stringPhormTRAdoburUIDCookieName       = this.strings.getString("PhormTRAdoburUIDCookieName");
    var stringPhormTRAdoburUIDCookieProtocol   = this.strings.getString("PhormTRAdoburUIDCookieProtocol");
    var stringPhormTRAdoburUIDCookiePath       = this.strings.getString("PhormTRAdoburUIDCookiePath");
    var stringPhormTRAdoburUIDCookieDomain     = this.strings.getString("PhormTRAdoburUIDCookieDomain");

    this.DeleteCookie(stringPhormTRAdoburUIDCookieName, stringPhormTRAdoburUIDCookieProtocol, stringPhormTRAdoburUIDCookiePath, stringPhormTRAdoburUIDCookieDomain);

  }, // end SetPhormTRAdoburOptOutCookies

 
  //----------------------------------------------------------------------------------------------------
  SetPhormTRAdoburUIDCookies: function() {
    dump("Dephormation: SetPhormTRAdoburUIDCookies randomising Phorm TR UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm BR cookies

    var stringPhormTRAdoburUIDCookieName       = this.strings.getString("PhormTRAdoburUIDCookieName");
    //var stringPhormTRAdoburUIDCookieValue      = this.strings.getString("PhormTRAdoburUIDCookieValue");
    var stringPhormTRAdoburUIDCookieProtocol   = this.strings.getString("PhormTRAdoburUIDCookieProtocol");
    var stringPhormTRAdoburUIDCookiePath       = this.strings.getString("PhormTRAdoburUIDCookiePath");
    var stringPhormTRAdoburUIDCookieDomain     = this.strings.getString("PhormTRAdoburUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormTRAdoburUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormTRAdoburUIDCookieName, stringPhormTRAdoburUIDCookieValue, stringPhormTRAdoburUIDCookieProtocol,
        stringPhormTRAdoburUIDCookiePath, stringPhormTRAdoburUIDCookieDomain);      

  }, // end SetPhormTRAdoburUIDCookies
  
  //----------------------------------------------------------------------------------------------------
  SetPhormCNMooDooOptOutCookies: function() {
    dump("Dephormation: SetPhormCNMooDooOptOutCookies setting CN opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm CN Optout cookies

    var stringPhormCNMooDooOptOutCookieName     = this.strings.getString("PhormCNMooDooOptOutCookieName");
    var stringPhormCNMooDooOptOutCookieValue    = this.strings.getString("PhormCNMooDooOptOutCookieValue");
    var stringPhormCNMooDooOptOutCookieProtocol = this.strings.getString("PhormCNMooDooOptOutCookieProtocol");
    var stringPhormCNMooDooOptOutCookiePath     = this.strings.getString("PhormCNMooDooOptOutCookiePath");
    var stringPhormCNMooDooOptOutCookieDomain   = this.strings.getString("PhormCNMooDooOptOutCookieDomain");

    this.OverwriteCookie( stringPhormCNMooDooOptOutCookieName, stringPhormCNMooDooOptOutCookieValue, stringPhormCNMooDooOptOutCookieProtocol,
        stringPhormCNMooDooOptOutCookiePath, stringPhormCNMooDooOptOutCookieDomain);      

    dump("Dephormation: SetPhormCNMooDooOptOutCookies erasing CN opt in cookies\n");

    // Erase Phorm CN Opt In cookies

    var stringPhormCNMooDooOptInCookieName     = this.strings.getString("PhormCNMooDooOptInCookieName");
    var stringPhormCNMooDooOptInCookieProtocol = this.strings.getString("PhormCNMooDooOptInCookieProtocol");
    var stringPhormCNMooDooOptInCookiePath     = this.strings.getString("PhormCNMooDooOptInCookiePath");
    var stringPhormCNMooDooOptInCookieDomain   = this.strings.getString("PhormCNMooDooOptInCookieDomain");

    this.DeleteCookie(stringPhormCNMooDooOptInCookieName, stringPhormCNMooDooOptInCookieProtocol, stringPhormCNMooDooOptInCookiePath, stringPhormCNMooDooOptInCookieDomain);

    dump("Dephormation: SetPhormCNMooDooOptOutCookies erasing CN UID cookies\n");

    // Erase Phorm CN UID cookies

    var stringPhormCNMooDooUIDCookieName       = this.strings.getString("PhormCNMooDooUIDCookieName");
    var stringPhormCNMooDooUIDCookieProtocol   = this.strings.getString("PhormCNMooDooUIDCookieProtocol");
    var stringPhormCNMooDooUIDCookiePath       = this.strings.getString("PhormCNMooDooUIDCookiePath");
    var stringPhormCNMooDooUIDCookieDomain     = this.strings.getString("PhormCNMooDooUIDCookieDomain");

    this.DeleteCookie(stringPhormCNMooDooUIDCookieName, stringPhormCNMooDooUIDCookieProtocol, stringPhormCNMooDooUIDCookiePath, stringPhormCNMooDooUIDCookieDomain);

  }, // end SetPhormCNMooDooOptOutCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormCNFengFengTieOptOutCookies: function() {
    dump("Dephormation: SetPhormCNFengFengTieOptOutCookies setting CN opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm CN Optout cookies

    var stringPhormCNFengFengTieOptOutCookieName     = this.strings.getString("PhormCNFengFengTieOptOutCookieName");
    var stringPhormCNFengFengTieOptOutCookieValue    = this.strings.getString("PhormCNFengFengTieOptOutCookieValue");
    var stringPhormCNFengFengTieOptOutCookieProtocol = this.strings.getString("PhormCNFengFengTieOptOutCookieProtocol");
    var stringPhormCNFengFengTieOptOutCookiePath     = this.strings.getString("PhormCNFengFengTieOptOutCookiePath");
    var stringPhormCNFengFengTieOptOutCookieDomain   = this.strings.getString("PhormCNFengFengTieOptOutCookieDomain");

    this.OverwriteCookie( stringPhormCNFengFengTieOptOutCookieName, stringPhormCNFengFengTieOptOutCookieValue, stringPhormCNFengFengTieOptOutCookieProtocol,
        stringPhormCNFengFengTieOptOutCookiePath, stringPhormCNFengFengTieOptOutCookieDomain);      

    dump("Dephormation: SetPhormCNFengFengTieOptOutCookies erasing CN opt in cookies\n");

    // Erase Phorm CN Opt In cookies

    var stringPhormCNFengFengTieOptInCookieName     = this.strings.getString("PhormCNFengFengTieOptInCookieName");
    var stringPhormCNFengFengTieOptInCookieProtocol = this.strings.getString("PhormCNFengFengTieOptInCookieProtocol");
    var stringPhormCNFengFengTieOptInCookiePath     = this.strings.getString("PhormCNFengFengTieOptInCookiePath");
    var stringPhormCNFengFengTieOptInCookieDomain   = this.strings.getString("PhormCNFengFengTieOptInCookieDomain");

    this.DeleteCookie(stringPhormCNFengFengTieOptInCookieName, stringPhormCNFengFengTieOptInCookieProtocol, stringPhormCNFengFengTieOptInCookiePath, stringPhormCNFengFengTieOptInCookieDomain);

    dump("Dephormation: SetPhormCNFengFengTieOptOutCookies erasing CN UID cookies\n");

    // Erase Phorm CN UID cookies

    var stringPhormCNFengFengTieUIDCookieName       = this.strings.getString("PhormCNFengFengTieUIDCookieName");
    var stringPhormCNFengFengTieUIDCookieProtocol   = this.strings.getString("PhormCNFengFengTieUIDCookieProtocol");
    var stringPhormCNFengFengTieUIDCookiePath       = this.strings.getString("PhormCNFengFengTieUIDCookiePath");
    var stringPhormCNFengFengTieUIDCookieDomain     = this.strings.getString("PhormCNFengFengTieUIDCookieDomain");

    this.DeleteCookie(stringPhormCNFengFengTieUIDCookieName, stringPhormCNFengFengTieUIDCookieProtocol, stringPhormCNFengFengTieUIDCookiePath, stringPhormCNFengFengTieUIDCookieDomain);

  }, // end SetPhormCNFengFengTieOptOutCookies
   //----------------------------------------------------------------------------------------------------
  SetPhormCNGenniOptOutCookies: function() {
    dump("Dephormation: SetPhormCNGenniOptOutCookies setting CN opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm CN Optout cookies

    var stringPhormCNGenniOptOutCookieName     = this.strings.getString("PhormCNGenniOptOutCookieName");
    var stringPhormCNGenniOptOutCookieValue    = this.strings.getString("PhormCNGenniOptOutCookieValue");
    var stringPhormCNGenniOptOutCookieProtocol = this.strings.getString("PhormCNGenniOptOutCookieProtocol");
    var stringPhormCNGenniOptOutCookiePath     = this.strings.getString("PhormCNGenniOptOutCookiePath");
    var stringPhormCNGenniOptOutCookieDomain   = this.strings.getString("PhormCNGenniOptOutCookieDomain");

    this.OverwriteCookie( stringPhormCNGenniOptOutCookieName, stringPhormCNGenniOptOutCookieValue, stringPhormCNGenniOptOutCookieProtocol,
        stringPhormCNGenniOptOutCookiePath, stringPhormCNGenniOptOutCookieDomain);      

    dump("Dephormation: SetPhormCNGenniOptOutCookies erasing CN opt in cookies\n");

    // Erase Phorm CN Opt In cookies

    var stringPhormCNGenniOptInCookieName     = this.strings.getString("PhormCNGenniOptInCookieName");
    var stringPhormCNGenniOptInCookieProtocol = this.strings.getString("PhormCNGenniOptInCookieProtocol");
    var stringPhormCNGenniOptInCookiePath     = this.strings.getString("PhormCNGenniOptInCookiePath");
    var stringPhormCNGenniOptInCookieDomain   = this.strings.getString("PhormCNGenniOptInCookieDomain");

    this.DeleteCookie(stringPhormCNGenniOptInCookieName, stringPhormCNGenniOptInCookieProtocol, stringPhormCNGenniOptInCookiePath, stringPhormCNGenniOptInCookieDomain);

    dump("Dephormation: SetPhormCNGenniOptOutCookies erasing CN UID cookies\n");

    // Erase Phorm CN UID cookies

    var stringPhormCNGenniUIDCookieName       = this.strings.getString("PhormCNGenniUIDCookieName");
    var stringPhormCNGenniUIDCookieProtocol   = this.strings.getString("PhormCNGenniUIDCookieProtocol");
    var stringPhormCNGenniUIDCookiePath       = this.strings.getString("PhormCNGenniUIDCookiePath");
    var stringPhormCNGenniUIDCookieDomain     = this.strings.getString("PhormCNGenniUIDCookieDomain");

    this.DeleteCookie(stringPhormCNGenniUIDCookieName, stringPhormCNGenniUIDCookieProtocol, stringPhormCNGenniUIDCookiePath, stringPhormCNGenniUIDCookieDomain);

  }, // end SetPhormCNGenniOptOutCookies
  
  //----------------------------------------------------------------------------------------------------
  SetPhormRUIMRKOptOutCookies: function() {
    dump("Dephormation: SetPhormRUIMRKOptOutCookies setting CN opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm RU Optout cookies

    var stringPhormRUIMRKOptOutCookieName     = this.strings.getString("PhormRUIMRKOptOutCookieName");
    var stringPhormRUIMRKOptOutCookieValue    = this.strings.getString("PhormRUIMRKOptOutCookieValue");
    var stringPhormRUIMRKOptOutCookieProtocol = this.strings.getString("PhormRUIMRKOptOutCookieProtocol");
    var stringPhormRUIMRKOptOutCookiePath     = this.strings.getString("PhormRUIMRKOptOutCookiePath");
    var stringPhormRUIMRKOptOutCookieDomain   = this.strings.getString("PhormRUIMRKOptOutCookieDomain");

    this.OverwriteCookie( stringPhormRUIMRKOptOutCookieName, stringPhormRUIMRKOptOutCookieValue, stringPhormRUIMRKOptOutCookieProtocol,
        stringPhormRUIMRKOptOutCookiePath, stringPhormRUIMRKOptOutCookieDomain);      

    dump("Dephormation: SetPhormRUIMRKOptOutCookies erasing RU opt in cookies\n");

    // Erase Phorm RU Opt In cookies

    var stringPhormRUIMRKOptInCookieName     = this.strings.getString("PhormRUIMRKOptInCookieName");
    var stringPhormRUIMRKOptInCookieProtocol = this.strings.getString("PhormRUIMRKOptInCookieProtocol");
    var stringPhormRUIMRKOptInCookiePath     = this.strings.getString("PhormRUIMRKOptInCookiePath");
    var stringPhormRUIMRKOptInCookieDomain   = this.strings.getString("PhormRUIMRKOptInCookieDomain");

    this.DeleteCookie(stringPhormRUIMRKOptInCookieName, stringPhormRUIMRKOptInCookieProtocol, stringPhormRUIMRKOptInCookiePath, stringPhormRUIMRKOptInCookieDomain);

    dump("Dephormation: SetPhormRUIMRKOptOutCookies erasing RU UID cookies\n");

    // Erase Phorm RU UID cookies

    var stringPhormRUIMRKUIDCookieName       = this.strings.getString("PhormRUIMRKUIDCookieName");
    var stringPhormRUIMRKUIDCookieProtocol   = this.strings.getString("PhormRUIMRKUIDCookieProtocol");
    var stringPhormRUIMRKUIDCookiePath       = this.strings.getString("PhormRUIMRKUIDCookiePath");
    var stringPhormRUIMRKUIDCookieDomain     = this.strings.getString("PhormRUIMRKUIDCookieDomain");

    this.DeleteCookie(stringPhormRUIMRKUIDCookieName, stringPhormRUIMRKUIDCookieProtocol, stringPhormRUIMRKUIDCookiePath, stringPhormRUIMRKUIDCookieDomain);

  }, // end SetPhormRUIMRKOptOutCookies

  //----------------------------------------------------------------------------------------------------
  SetPhorm__FideoOptOutCookies: function() {
    dump("Dephormation: SetPhorm__FideoOptOutCookies setting Fideo opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm Fideo Optout cookies

    var stringPhorm__FideoOptOutCookieName     = this.strings.getString("Phorm__FideoOptOutCookieName");
    var stringPhorm__FideoOptOutCookieValue    = this.strings.getString("Phorm__FideoOptOutCookieValue");
    var stringPhorm__FideoOptOutCookieProtocol = this.strings.getString("Phorm__FideoOptOutCookieProtocol");
    var stringPhorm__FideoOptOutCookiePath     = this.strings.getString("Phorm__FideoOptOutCookiePath");
    var stringPhorm__FideoOptOutCookieDomain   = this.strings.getString("Phorm__FideoOptOutCookieDomain");

    this.OverwriteCookie( stringPhorm__FideoOptOutCookieName, stringPhorm__FideoOptOutCookieValue, stringPhorm__FideoOptOutCookieProtocol,
        stringPhorm__FideoOptOutCookiePath, stringPhorm__FideoOptOutCookieDomain);      

    dump("Dephormation: SetPhorm__FideoOptOutCookies erasing Fideo opt in cookies\n");

    // Erase Phorm Fideo Opt In cookies

    var stringPhorm__FideoOptInCookieName     = this.strings.getString("Phorm__FideoOptInCookieName");
    var stringPhorm__FideoOptInCookieProtocol = this.strings.getString("Phorm__FideoOptInCookieProtocol");
    var stringPhorm__FideoOptInCookiePath     = this.strings.getString("Phorm__FideoOptInCookiePath");
    var stringPhorm__FideoOptInCookieDomain   = this.strings.getString("Phorm__FideoOptInCookieDomain");

    this.DeleteCookie(stringPhorm__FideoOptInCookieName, stringPhorm__FideoOptInCookieProtocol, stringPhorm__FideoOptInCookiePath, stringPhorm__FideoOptInCookieDomain);

    dump("Dephormation: SetPhorm__FideoOptOutCookies erasing Fideo UID cookies\n");

    // Erase Phorm Fideo UID cookies

    var stringPhorm__FideoUIDCookieName       = this.strings.getString("Phorm__FideoUIDCookieName");
    var stringPhorm__FideoUIDCookieProtocol   = this.strings.getString("Phorm__FideoUIDCookieProtocol");
    var stringPhorm__FideoUIDCookiePath       = this.strings.getString("Phorm__FideoUIDCookiePath");
    var stringPhorm__FideoUIDCookieDomain     = this.strings.getString("Phorm__FideoUIDCookieDomain");

    this.DeleteCookie(stringPhorm__FideoUIDCookieName, stringPhorm__FideoUIDCookieProtocol, stringPhorm__FideoUIDCookiePath, stringPhorm__FideoUIDCookieDomain);

  }, // end SetPhorm__FideoOptOutCookies

  //----------------------------------------------------------------------------------------------------
  SetPhorm__PhluidMediaOptOutCookies: function() {
    dump("Dephormation: SetPhorm__PhluidMediaOptOutCookies setting PhluidMedia opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm PhluidMedia Optout cookies

    var stringPhorm__PhluidMediaOptOutCookieName     = this.strings.getString("Phorm__PhluidMediaOptOutCookieName");
    var stringPhorm__PhluidMediaOptOutCookieValue    = this.strings.getString("Phorm__PhluidMediaOptOutCookieValue");
    var stringPhorm__PhluidMediaOptOutCookieProtocol = this.strings.getString("Phorm__PhluidMediaOptOutCookieProtocol");
    var stringPhorm__PhluidMediaOptOutCookiePath     = this.strings.getString("Phorm__PhluidMediaOptOutCookiePath");
    var stringPhorm__PhluidMediaOptOutCookieDomain   = this.strings.getString("Phorm__PhluidMediaOptOutCookieDomain");

    this.OverwriteCookie( stringPhorm__PhluidMediaOptOutCookieName, stringPhorm__PhluidMediaOptOutCookieValue, stringPhorm__PhluidMediaOptOutCookieProtocol,
        stringPhorm__PhluidMediaOptOutCookiePath, stringPhorm__PhluidMediaOptOutCookieDomain);      

    dump("Dephormation: SetPhorm__PhluidMediaOptOutCookies erasing PhluidMedia opt in cookies\n");

    // Erase Phorm PhluidMedia Opt In cookies

    var stringPhorm__PhluidMediaOptInCookieName     = this.strings.getString("Phorm__PhluidMediaOptInCookieName");
    var stringPhorm__PhluidMediaOptInCookieProtocol = this.strings.getString("Phorm__PhluidMediaOptInCookieProtocol");
    var stringPhorm__PhluidMediaOptInCookiePath     = this.strings.getString("Phorm__PhluidMediaOptInCookiePath");
    var stringPhorm__PhluidMediaOptInCookieDomain   = this.strings.getString("Phorm__PhluidMediaOptInCookieDomain");

    this.DeleteCookie(stringPhorm__PhluidMediaOptInCookieName, stringPhorm__PhluidMediaOptInCookieProtocol, stringPhorm__PhluidMediaOptInCookiePath, stringPhorm__PhluidMediaOptInCookieDomain);

    dump("Dephormation: SetPhorm__PhluidMediaOptOutCookies erasing PhluidMedia UID cookies\n");

    // Erase Phorm PhluidMedia UID cookies

    var stringPhorm__PhluidMediaUIDCookieName       = this.strings.getString("Phorm__PhluidMediaUIDCookieName");
    var stringPhorm__PhluidMediaUIDCookieProtocol   = this.strings.getString("Phorm__PhluidMediaUIDCookieProtocol");
    var stringPhorm__PhluidMediaUIDCookiePath       = this.strings.getString("Phorm__PhluidMediaUIDCookiePath");
    var stringPhorm__PhluidMediaUIDCookieDomain     = this.strings.getString("Phorm__PhluidMediaUIDCookieDomain");

    this.DeleteCookie(stringPhorm__PhluidMediaUIDCookieName, stringPhorm__PhluidMediaUIDCookieProtocol, stringPhorm__PhluidMediaUIDCookiePath, stringPhorm__PhluidMediaUIDCookieDomain);

  }, // end SetPhorm__PhluidMediaOptOutCookies
      
  //----------------------------------------------------------------------------------------------------
  SetPhorm__MooDooCNOptOutCookies: function() {
    dump("Dephormation: SetPhorm__MooDooCNOptOutCookies setting MooDooCN opt out cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("disablePhorm")))
      return;

    window.status= this.strings.getString("StatusDisablingPhorm");

    // Set Phorm MooDooCN Optout cookies

    var stringPhorm__MooDooCNOptOutCookieName     = this.strings.getString("Phorm__MooDooCNOptOutCookieName");
    var stringPhorm__MooDooCNOptOutCookieValue    = this.strings.getString("Phorm__MooDooCNOptOutCookieValue");
    var stringPhorm__MooDooCNOptOutCookieProtocol = this.strings.getString("Phorm__MooDooCNOptOutCookieProtocol");
    var stringPhorm__MooDooCNOptOutCookiePath     = this.strings.getString("Phorm__MooDooCNOptOutCookiePath");
    var stringPhorm__MooDooCNOptOutCookieDomain   = this.strings.getString("Phorm__MooDooCNOptOutCookieDomain");

    this.OverwriteCookie( stringPhorm__MooDooCNOptOutCookieName, stringPhorm__MooDooCNOptOutCookieValue, stringPhorm__MooDooCNOptOutCookieProtocol,
        stringPhorm__MooDooCNOptOutCookiePath, stringPhorm__MooDooCNOptOutCookieDomain);      

    dump("Dephormation: SetPhorm__MooDooCNOptOutCookies erasing MooDooCN opt in cookies\n");

    // Erase Phorm MooDooCN Opt In cookies

    var stringPhorm__MooDooCNOptInCookieName     = this.strings.getString("Phorm__MooDooCNOptInCookieName");
    var stringPhorm__MooDooCNOptInCookieProtocol = this.strings.getString("Phorm__MooDooCNOptInCookieProtocol");
    var stringPhorm__MooDooCNOptInCookiePath     = this.strings.getString("Phorm__MooDooCNOptInCookiePath");
    var stringPhorm__MooDooCNOptInCookieDomain   = this.strings.getString("Phorm__MooDooCNOptInCookieDomain");

    this.DeleteCookie(stringPhorm__MooDooCNOptInCookieName, stringPhorm__MooDooCNOptInCookieProtocol, stringPhorm__MooDooCNOptInCookiePath, stringPhorm__MooDooCNOptInCookieDomain);

    dump("Dephormation: SetPhorm__MooDooCNOptOutCookies erasing MooDooCN UID cookies\n");

    // Erase Phorm MooDooCN UID cookies

    var stringPhorm__MooDooCNUIDCookieName       = this.strings.getString("Phorm__MooDooCNUIDCookieName");
    var stringPhorm__MooDooCNUIDCookieProtocol   = this.strings.getString("Phorm__MooDooCNUIDCookieProtocol");
    var stringPhorm__MooDooCNUIDCookiePath       = this.strings.getString("Phorm__MooDooCNUIDCookiePath");
    var stringPhorm__MooDooCNUIDCookieDomain     = this.strings.getString("Phorm__MooDooCNUIDCookieDomain");

    this.DeleteCookie(stringPhorm__MooDooCNUIDCookieName, stringPhorm__MooDooCNUIDCookieProtocol, stringPhorm__MooDooCNUIDCookiePath, stringPhorm__MooDooCNUIDCookieDomain);

  }, // end SetPhorm__MooDooCNOptOutCookies
    
  //----------------------------------------------------------------------------------------------------
  SetPhormCNMooDooUIDCookies: function() {
    dump("Dephormation: SetPhormCNMooDooUIDCookies randomising Phorm CN MooDoo UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm CN cookies

    var stringPhormCNMooDooUIDCookieName       = this.strings.getString("PhormCNMooDooUIDCookieName");
    //var stringPhormCNMooDooUIDCookieValue      = this.strings.getString("PhormCNMooDooUIDCookieValue");
    var stringPhormCNMooDooUIDCookieProtocol   = this.strings.getString("PhormCNMooDooUIDCookieProtocol");
    var stringPhormCNMooDooUIDCookiePath       = this.strings.getString("PhormCNMooDooUIDCookiePath");
    var stringPhormCNMooDooUIDCookieDomain     = this.strings.getString("PhormCNMooDooUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormCNMooDooUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormCNMooDooUIDCookieName, stringPhormCNMooDooUIDCookieValue, stringPhormCNMooDooUIDCookieProtocol,
        stringPhormCNMooDooUIDCookiePath, stringPhormCNMooDooUIDCookieDomain);      

  }, // end SetPhormCNMooDooUIDCookies

    //----------------------------------------------------------------------------------------------------
  SetPhormCNFengFengTieUIDCookies: function() {
    dump("Dephormation: SetPhormCNFengFengTieUIDCookies randomising Phorm CN FengFengTie UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm CN cookies

    var stringPhormCNFengFengTieUIDCookieName       = this.strings.getString("PhormCNFengFengTieUIDCookieName");
    //var stringPhormCNFengFengTieUIDCookieValue      = this.strings.getString("PhormCNFengFengTieUIDCookieValue");
    var stringPhormCNFengFengTieUIDCookieProtocol   = this.strings.getString("PhormCNFengFengTieUIDCookieProtocol");
    var stringPhormCNFengFengTieUIDCookiePath       = this.strings.getString("PhormCNFengFengTieUIDCookiePath");
    var stringPhormCNFengFengTieUIDCookieDomain     = this.strings.getString("PhormCNFengFengTieUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormCNFengFengTieUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormCNFengFengTieUIDCookieName, stringPhormCNFengFengTieUIDCookieValue, stringPhormCNFengFengTieUIDCookieProtocol,
        stringPhormCNFengFengTieUIDCookiePath, stringPhormCNFengFengTieUIDCookieDomain);      

  }, // end SetPhormCNFengFengTieUIDCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormCNGenniUIDCookies: function() {
    dump("Dephormation: SetPhormCNGenniUIDCookies randomising Phorm CN Genni UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm CN cookies

    var stringPhormCNGenniUIDCookieName       = this.strings.getString("PhormCNGenniUIDCookieName");
    //var stringPhormCNGenniUIDCookieValue      = this.strings.getString("PhormCNGenniUIDCookieValue");
    var stringPhormCNGenniUIDCookieProtocol   = this.strings.getString("PhormCNGenniUIDCookieProtocol");
    var stringPhormCNGenniUIDCookiePath       = this.strings.getString("PhormCNGenniUIDCookiePath");
    var stringPhormCNGenniUIDCookieDomain     = this.strings.getString("PhormCNGenniUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormCNGenniUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormCNGenniUIDCookieName, stringPhormCNGenniUIDCookieValue, stringPhormCNGenniUIDCookieProtocol,
        stringPhormCNGenniUIDCookiePath, stringPhormCNGenniUIDCookieDomain);      

  }, // end SetPhormCNGenniUIDCookies

  //----------------------------------------------------------------------------------------------------
  SetPhormRUIMRKUIDCookies: function() {
    dump("Dephormation: SetPhormRUIMRKUIDCookies randomising PhormRU IMRK UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm RU cookies

    var stringPhormRUIMRKUIDCookieName       = this.strings.getString("PhormRUIMRKUIDCookieName");
    //var stringPhormRUIMRKUIDCookieValue      = this.strings.getString("PhormRUIMRKUIDCookieValue");
    var stringPhormRUIMRKUIDCookieProtocol   = this.strings.getString("PhormRUIMRKUIDCookieProtocol");
    var stringPhormRUIMRKUIDCookiePath       = this.strings.getString("PhormRUIMRKUIDCookiePath");
    var stringPhormRUIMRKUIDCookieDomain     = this.strings.getString("PhormRUIMRKUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhormRUIMRKUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhormRUIMRKUIDCookieName, stringPhormRUIMRKUIDCookieValue, stringPhormRUIMRKUIDCookieProtocol,
        stringPhormRUIMRKUIDCookiePath, stringPhormRUIMRKUIDCookieDomain);      

  }, // end SetPhormRUIMRKUIDCookies

  //----------------------------------------------------------------------------------------------------
  SetPhorm__FideoUIDCookies: function() {
    dump("Dephormation: SetPhorm__FideoUIDCookies randomising Fideo UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm cookies

    var stringPhorm__FideoUIDCookieName       = this.strings.getString("Phorm__FideoUIDCookieName");
    //var stringPhorm__FideoUIDCookieValue      = this.strings.getString("Phorm__FideoUIDCookieValue");
    var stringPhorm__FideoUIDCookieProtocol   = this.strings.getString("Phorm__FideoUIDCookieProtocol");
    var stringPhorm__FideoUIDCookiePath       = this.strings.getString("Phorm__FideoUIDCookiePath");
    var stringPhorm__FideoUIDCookieDomain     = this.strings.getString("Phorm__FideoUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhorm__FideoUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhorm__FideoUIDCookieName, stringPhorm__FideoUIDCookieValue, stringPhorm__FideoUIDCookieProtocol,
        stringPhorm__FideoUIDCookiePath, stringPhorm__FideoUIDCookieDomain);      

  }, // end SetPhorm__FideoUIDCookies

  //----------------------------------------------------------------------------------------------------
  SetPhorm__PhluidMediaUIDCookies: function() {
    dump("Dephormation: SetPhorm__PhluidMediaUIDCookies randomising PhluidMedia UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm cookies

    var stringPhorm__PhluidMediaUIDCookieName       = this.strings.getString("Phorm__PhluidMediaUIDCookieName");
    //var stringPhorm__PhluidMediaUIDCookieValue      = this.strings.getString("Phorm__PhluidMediaUIDCookieValue");
    var stringPhorm__PhluidMediaUIDCookieProtocol   = this.strings.getString("Phorm__PhluidMediaUIDCookieProtocol");
    var stringPhorm__PhluidMediaUIDCookiePath       = this.strings.getString("Phorm__PhluidMediaUIDCookiePath");
    var stringPhorm__PhluidMediaUIDCookieDomain     = this.strings.getString("Phorm__PhluidMediaUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhorm__PhluidMediaUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhorm__PhluidMediaUIDCookieName, stringPhorm__PhluidMediaUIDCookieValue, stringPhorm__PhluidMediaUIDCookieProtocol,
        stringPhorm__PhluidMediaUIDCookiePath, stringPhorm__PhluidMediaUIDCookieDomain);      

  }, // end SetPhorm__PhluidMediaUIDCookies
  //----------------------------------------------------------------------------------------------------
  SetPhorm__MooDooCNUIDCookies: function() {
    dump("Dephormation: SetPhorm__MooDooCNUIDCookies randomising MooDooCN UID cookies\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("randomizePhormUID")))
      return;

    window.status= this.strings.getString("StatusRandomisingPhormUID");

    // Corrupt Phorm CN cookies

    var stringPhorm__MooDooCNUIDCookieName       = this.strings.getString("Phorm__MooDooCNUIDCookieName");
    //var stringPhorm__MooDooCNUIDCookieValue      = this.strings.getString("Phorm__MooDooCNUIDCookieValue");
    var stringPhorm__MooDooCNUIDCookieProtocol   = this.strings.getString("Phorm__MooDooCNUIDCookieProtocol");
    var stringPhorm__MooDooCNUIDCookiePath       = this.strings.getString("Phorm__MooDooCNUIDCookiePath");
    var stringPhorm__MooDooCNUIDCookieDomain     = this.strings.getString("Phorm__MooDooCNUIDCookieDomain");

    // Create a corrupted base64 encoded UID cookie value
    var stringPhorm__MooDooCNUIDCookieValue = RandomUID(65);

    this.OverwriteCookie( stringPhorm__MooDooCNUIDCookieName, stringPhorm__MooDooCNUIDCookieValue, stringPhorm__MooDooCNUIDCookieProtocol,
        stringPhorm__MooDooCNUIDCookiePath, stringPhorm__MooDooCNUIDCookieDomain);      

  }, // end SetPhorm__MooDooCNUIDCookies


  
  //----------------------------------------------------------------------------------------------------
  OverwriteCookie: function(stringName, stringValue, stringProtocol, stringPath, stringDomain) {
    dump("Dephormation: OverwriteCookie Overwriting cookie\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    var uriCookieURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);

    uriCookieURI.spec = stringProtocol + "://" + stringDomain + stringPath;

    var stringCookie =  stringName + "=" + stringValue + ";" ;

    if (stringDomain) 
      stringCookie += "domain=" + stringDomain + ";" ;

    var expiryDate = new Date ( 2038, 0, 1 );

    stringCookie += "expires=" + expiryDate.toGMTString() + ";" ;

    if (stringPath) 
      stringCookie += "path=" + stringPath + ";" ;

    if (stringProtocol == "https") 
      stringCookie += "secure" ;

    dump(stringCookie);
    dump("\n");

    try {
       // Disable cookie warnings
       // Set semphore used to co-ordinate with cookie detection code
       preferences.setBoolPref("suppressCookieSettingAlerts", true);

       var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService().QueryInterface(Components.interfaces.nsICookieService);

       // Set the new cookie
       var rv = cookieService.setCookieString(uriCookieURI, null, stringCookie, null );

    }
    catch (err) {
       dump("Dephormation: failed to overwrite cookie :( \n");
       dump(err.message);
       dump("\n");
       alert( this.strings.getString("FailedToSetCookies") ); 
       alert(err.message);
    }
    // Enable cookie warnings
    // Clear semphore used to co-ordinate with cookie detection code
    preferences.setBoolPref("suppressCookieSettingAlerts", false );
  }, // end OverwriteCookie

  //----------------------------------------------------------------------------------------------------
  DeleteCookie: function(stringName, stringProtocol, stringPath, stringDomain) {
    dump("Dephormation: DeleteCookie Deleting cookie\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    var uriCookieURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);

    uriCookieURI.spec = stringProtocol + "://" + stringDomain + stringPath;

    var stringExpiredCookie = stringName + "=expired;" ;

    if (stringDomain) 
      stringExpiredCookie += "domain=" + stringDomain + ";" ;

    var expiredDate = new Date ( 2000, 0, 1 );

    stringExpiredCookie += "expires=" + expiredDate.toGMTString() + ";" ;

    if (stringPath) 
      stringExpiredCookie += "path=" + stringPath + ";" ;

    if (stringProtocol == "https")
      stringExpiredCookie += "secure" ;

    dump(stringExpiredCookie);
    dump("\n");

    try {
       // Disable cookie warnings
       // Set semphore used to co-ordinate with cookie detection code
       preferences.setBoolPref("suppressCookieSettingAlerts", true);

       var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService().QueryInterface(Components.interfaces.nsICookieService);

       // Remove old cookies
       var rv = cookieService.setCookieString(uriCookieURI, null, stringExpiredCookie, null );

    }
    catch (err) {
       dump("Dephormation: failed to delete cookie :( \n");
       dump(err.message);
       dump("\n");
       alert( this.strings.getString("FailedToDeleteCookies") ); 
       alert(err.message);
    }
    // Enable cookie warnings
    // Clear semphore used to co-ordinate with cookie detection code
    preferences.setBoolPref("suppressCookieSettingAlerts", false );
  }, // end DeleteCookie

  //----------------------------------------------------------------------------------------------------
  // Rewrite Flash LSOs, either an opt out, else if randomisation of UIDs is selected a randomised UID
  // NB: Can't currently opt out AND randomise the UID, must be one or the other or neither
  RewritePhormFlashLSO: function() {
    dump("Dephormation: RewritePhormFlashLSO rewriting Flash LSOs\n");

    // Get the "extensions.dephormation." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.")

    if (!(preferences.getBoolPref("enableFlashLSORewriting")))
      return;

    window.status= this.strings.getString("StatusRewritingFlashLSOs");

    writePhormBRFlashLSO(RandomUID(65));
    writePhormTRGezintiFlashLSO(RandomUID(65));
    writePhormTRAdoburFlashLSO(RandomUID(65));
    writePhormCNMooDooFlashLSO(RandomUID(65));
    writePhormCNFengFengTieFlashLSO(RandomUID(65));
    writePhormCNGenniFlashLSO(RandomUID(65));
    writePhormRUIMRKFlashLSO(RandomUID(65));
    writePhorm__FideoFlashLSO(RandomUID(65));
    writePhorm__PhluidMediaFlashLSO(RandomUID(65));
    writePhorm__MooDooCNFlashLSO(RandomUID(65));

  }, // end RewritePhormFlashLSO

  // ------------------------------------------------------------------------------------------------
  // Set the text in the status bar panel and toolbar icons
  updateGUIStatus: function(status, tooltip, icon, css){
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.dephormation.");

     var label="uninitialised";
     var image="uninitialised";
     var tooltiptext="uninitialised";
     var style="uninitialised";

     if (arguments.length < 1)
     {
        if (preferences.getBoolPref("disablePhorm"))
        {
            label = dephormation.strings.getString("Dephormation_Active");
            image = "chrome://dephormation/skin/blueflag.gif";
            tooltiptext = dephormation.strings.getString("Dephormation_Active");
            style = "color:#000066; font-weight:bold;";
        }
        else
        {
           label = dephormation.strings.getString("Dephormation_Inactive");
           image = "chrome://dephormation/skin/yellowflag.gif";
           tooltiptext = dephormation.strings.getString("Dephormation_Inactive");
           style = "color:#cc6600; font-weight:bold;";
        }
     }
     else if (arguments.length < 2)
     {
        label=status;
        tooltiptext=label;
        image="chrome://dephormation/skin/blueflag.gif";
        style="";
     }
     else if (arguments.length < 3)
     {
        label=status;
        tooltiptext=tooltip;
        image="chrome://dephormation/skin/blueflag.gif";
        style="";
     }
     else if (arguments.length < 4)
     {
        label=status;
        tooltiptext=tooltip;
        image=icon;
        style="";
     }
     else
     {
        label=status;
        tooltiptext=tooltip;
        image=icon;
        style=css;
     }     
     
  // Set the status bar message
     try {
         var Dephormation_statusbarpanel = document.getElementById("Dephormation_statusbarpanel");
         Dephormation_statusbarpanel.image = image;
         Dephormation_statusbarpanel.label = label;
         Dephormation_statusbarpanel.setAttribute("tooltiptext", tooltiptext);
         Dephormation_statusbarpanel.setAttribute("style", style);
     } 
     catch(e)
     {
dump("Dephormation: updateGUIStatus: Can't set Dephormation status bar panel status. No Dephormation status bar panel? Exception;" + e.message + "\n");
     }
     
  // Copy status to toolbarbutton
     try {
         var Dephormation_toolbarbutton = document.getElementById("Dephormation_toolbarbutton");
         Dephormation_toolbarbutton.image = image;
         Dephormation_toolbarbutton.label = label;
         Dephormation_toolbarbutton.setAttribute("tooltiptext", tooltiptext);
         Dephormation_toolbarbutton.setAttribute("style", style);
         Dephormation_toolbarbutton.setAttribute("image", image);//seamonkey workaround
         Dephormation_toolbarbutton.setAttribute("label", label);//seamonkey workaround
     }
     catch(e)
     {
dump("Dephormation: updateGUIStatus: Can't set Dephormation toolbar bar button status. No Dephormation toolbar button? Exception;" + e.message + "\n");
     }
 },
 
 // ------------------------------------------------------------------------------------------------
 // Add an entry to the summary report
 addReportEntry: function(message){
    var currentTime  = new Date();
    var messageTime  = ISODateString(currentTime);
    var datedMessage = messageTime + " " + message;

    dephormation.report = dephormation.report + "\n" + datedMessage;
    
    var reportBufferLength = dephormation.report.length;
    var maxReportBufferLength = 65536;

    if (reportBufferLength > maxReportBufferLength ) {
       var truncatedReport = dephormation.report.substring(reportBufferLength-maxReportBufferLength);
       dephormation.report = truncatedReport;
    }
 }
  
}

